#include<iostream>
#include<vector>
using namespace std;

const int MAXN=1e6, MOD=1e9+7;

int p[MAXN], q[MAXN], v[MAXN];
bool usd[MAXN];
vector<int> comp;

long long GetAns(int idx, int k)
{
    if(k>comp.size()-idx)
    {
        return 0;
    }

    if(idx==comp.size())
    {
        return 1;
    }

    return ((((comp[idx]*k)%MOD)*GetAns(idx+1, k-1))%MOD+GetAns(idx+1, k))%MOD;
}

bool Fill(int n)
{
    for(int i=0; i<n; i++)
    {
        v[i]=0, p[i]=-1;
    }

    //CheckDuplicates
    for(int i=0; i<n; i++)
    {
        v[q[i]]++;

        if(v[q[i]]>2 || (v[q[i]]==2 && (i==1 || q[i]!=q[i-2])))
        {
            return false;
        }
    }

    //FillPairs
    for(int i=2; i<n; i++)
    {
        if(q[i]==q[i-2])
        {
            p[i-1]=q[i];
        }
    }

    //FillFirst
    if(p[1]==-1)
    {
        p[1]=q[0];
    }

    //FillLast
    if(p[n-2]!=-1 && p[n-2]!=q[n-1])
    {
        return false;
    }
    else if(p[n-2]==-1)
    {
        p[n-2]=q[n-1];
    }

    //FillRight
    for(int i=1; i<n-1; i++)
    {
        if(p[i-1]!=-1 && p[i-1]!=q[i])
        {
            p[i+1]=q[i];
        }
    }

    //FillLeft
    for(int i=n-2; i>0; i--)
    {
        if(p[i+1]!=-1 && p[i+1]!=q[i])
        {
            if(p[i-1]!=-1 && p[i-1]!=q[i])
            {
                return false;
            }
            else if(p[i-1]==-1)
            {
                p[i-1]=q[i];
            }
        }
    }

    //CheckSpecial
    if(p[n-2]!=-1 && p[n-2]!=q[n-1])
    {
        return false;
    }

    return true;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        cin >> q[i];
        q[i]--;
    }

    if(!Fill(n))
    {
        cout << "0\n";
    }
    else
    {
        long long ans=1;
        int s=0, cnt=0;
        for(int i=0; i<n; i+=2)
        {
            if(p[i]==-1)
            {
                s++;
            }
            else if(s!=0)
            {
                ans=(ans*s)%MOD;
                cnt++;
                s=0;
            }
        }

        if(s>0)
        {
            ans=(ans*s)%MOD;
                cnt++;
        }

        s=0;
        for(int i=1; i<n; i+=2)
        {
            if(p[i]==-1)
            {
                s++;
            }
            else if(s!=0)
            {
                ans=(ans*s)%MOD;
                cnt++;
                s=0;
            }
        }

        if(s>0)
        {
            ans=(ans*s)%MOD;
                cnt++;
        }

        for(int i=0; i<n; i++)
        {
            if(v[i]==0)
            {
                cnt--;
            }
        }

        if(cnt!=0)
        {
            cout << "0\n";
        }
        else
        {
            cout << ans << "\n";
        }
    }

    return 0;
}
