#include<iostream>
using namespace std;

const int MAXN=1e4, MOD=1e9+7;

long long dp[MAXN+1], s[MAXN+1];

long long GetAns(int n, int x, int k)
{
    for(int i=0; i<=n; i++)
    {
        dp[i]=0, s[i]=0;
    }

    dp[0]=1, s[0]=1;
    for(int i=0; i<k; i++)
    {
        long long sum=0;
        for(int j=0; j<=n; j++)
        {
            s[j]=dp[j];
            dp[j]=(dp[j]+sum)%MOD;
            sum=(sum+s[j])%MOD;

            if(j-x>=0)
            {
                sum=(sum-s[j-x]+MOD)%MOD;
            }
        }
    }

    return dp[n];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, a, b, k;
    cin >> n >> m >> a >> b >> k;

    cout << (GetAns(n, a, k)*GetAns(m, b, k))%MOD << "\n";

    return 0;
}
