#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

const int MAXM=1e4;

int ans[MAXM];

int GetAns(vector<pair<int, int> > v, int m)
{
    for(int i=0; i<m; i++)
    {
        ans[i]=-1;
    }

    int n=5, l=0, r=m-1;
    for(int i=0; i<n && l<=r; i++)
    {
        while(v[i].second>0 && l<=r)
        {
            ans[l]=v[i].first;
            v[i].second--;
            l+=2;

            if(r>=l && v[i].second>0)
            {
                ans[r]=v[i].first;
                v[i].second--;
                r-=2;
            }
        }
    }

    l=1, r=m-2;
    for(int i=n-1; i>=0 && l<=r; i--)
    {
        while(v[i].second>0)
        {
            ans[l]=v[i].first;
            v[i].second--;
            l+=2;

            if(r>=l && v[i].second>0)
            {
                ans[r]=v[i].first;
                v[i].second--;
                r-=2;
            }
        }
    }

    for(int i=0; i<m; i++)
    {
        if(ans[i]==-1)
        {
            for(int j=0; j<n; j++)
            {
                if(v[j].second!=0)
                {
                    ans[i]=v[j].first;
                }
            }
        }
    }

    int res=0;
    for(int i=1; i<m; i++)
    {
        res+=max(0, ans[i]+ans[i-1]-n);
    }

    return res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n=5, m=0;

    vector<pair<int, int> > v1, v2;
    for(int i=1; i<=n; i++)
    {
        int x;
        cin >> x;
        m+=x;

        v1.push_back({i, x});
        v2.push_back({i, x});
    }
    reverse(v2.begin(), v2.end());

    cout << min(GetAns(v1, m), GetAns(v2, m)) << "\n";

    return 0;
}
