#include<iostream>
#include<vector>

using namespace std;

struct Edge{
    int endPl;
    int leng;
    int magic;
};
struct Place{
    vector<Edge> roads;
    bool isDest;
    int br;
    int id;
};


void Pathways(int m, int time, int avMagic, int trips, int* minTime, Place* strt, Place* crr){
    Place crrObj=*crr;
    if(crrObj.isDest){
        if(time<*(minTime)){
            *(minTime)=time;
        }
        return;
    }
    if(trips>m*3){
        return;
    }
    for(int i=0; i<crrObj.br;i++){
        if(crrObj.roads[i].leng-avMagic>=0){
            Pathways(m, time+(crrObj.roads[i].leng-avMagic), crrObj.roads[i].magic, trips++, minTime, strt, strt+crrObj.roads[i].endPl);
        }else{
            Pathways(m, time, (avMagic-crrObj.roads[i].leng)+crrObj.roads[i].magic, trips++, minTime, strt, strt+crrObj.roads[i].endPl);
        }
    }
}

int main(){
    int M, N, a=0;
    vector<Place> places;
    Edge road;
    Place pl;
    cin>>M>>N;
    pl.isDest=false;
    pl.br=0;
    for(int i=0;i<M;i++){
        pl.id=i;
        places.push_back(pl);
    }
    for(int i=0;i<N;i++){
        int endPl;
        cin>>a>>endPl>>road.leng>>road.magic;
        road.endPl=endPl-1;
        places[a-1].roads.push_back(road);
        places[a-1].br++;
    }
    places[M-1].isDest=true;
    int minTime=3000;
    Pathways(N, 0, 0, 0, &minTime, &places[0], &places[0]);
    cout<<minTime;
}
