#include <iostream>
#include <vector>
#include <set>
#include <limits.h>
using namespace std;

int dp[3010][3010];
int N,M,A,B,K;
int END,JUMP;
long long mod=1000000007;
int solve(int pos,int turns)
{
	if(turns>K)return 0;
	if(pos>END)return 0;
	if(pos==END&&turns<=K)return 1;
	if(dp[pos][turns]!=-1)return dp[pos][turns];
	long long total=0;
	for(int i=0;i<=JUMP;i++)
		total+=solve(pos+i,turns+1);
	total%=mod;
	return dp[pos][turns]=total;
}

long long init()
{
	cin>>N>>M>>A>>B>>K;
	END=N;
	JUMP=A;
	for(int i=0;i<=N+2;i++)
		for(int j=0;j<=K+2;j++)
			dp[i][j]=-1;
	long long resx=solve(0,0);
	for(int i=0;i<=M+2;i++)
		for(int j=0;j<=K+2;j++)
			dp[i][j]=-1;
	END=M;
	JUMP=B;
	long long resy=solve(0,0);
	return (resy*resx)%mod;
}

int main()
{
 	cout<<init()<<endl;
 	
}
