#include <bits/stdc++.h>
#define MAXN 1000005
#define MOD 1000000007
#define endl '\n'
using namespace std;
typedef long long ll;
int n;
int p[MAXN];
int q[MAXN];
int idx[MAXN];
int cnt[MAXN];
bool used[MAXN];
vector<int> updated;

void input()
{
    cin >> n;
    for (int i = 1; i <= n; ++i)
    {
        p[i] = -1;
        cin >> q[i];
    }

    p[0] = MAXN;
    p[n + 1] = MAXN;
    p[2] = q[1];
    p[n - 1] = q[n];
}

void print()
{
    for (int i = 1; i <= n; ++i)
        cout << p[i] << " ";
    cout << endl;
}

bool check()
{
    for (int i = 1; i <= n; ++i)
        idx[i] = -1;

    for (int i = 1; i <= n; ++i)
    {
        ++cnt[q[i]];
        if (cnt[q[i]] >= 3)
            return false;

        if (idx[q[i]] != -1)
        {
            if (idx[q[i]] + 2 != i)
                return false;
            else
            {
                p[i - 1] = q[i];
            }
        }

        idx[q[i]] = i;
    }

    return true;
}

void solve()
{
    if (!check())
    {
        cout << 0 << endl;
        return;
    }

    //print();

    for (int i = 1; i <= n; ++i)
        if (p[i] != -1)
        {
            updated.push_back(i);
            used[p[i]] = 1;
        }

    while (!updated.empty())
    {
        int sz = updated.size();
        vector<int> v;
        //cout << "loop: " << endl;
        for (int j = 0; j < sz; ++j)
        {
            int i = updated[j];

            if (p[i] != -1)
            {
                //cout << i << " - " << p[i] << endl;
                if (p[i] != q[i + 1] && p[i] != q[i - 1])
                {
                    cout << 0 << endl;
                    return;
                }

                if (p[i] != q[i + 1] && p[i + 2] == -1)
                {
                    p[i + 2] = q[i + 1];
                    used[p[i + 2]] = 1;
                    v.push_back(i + 2);
                }
                if (p[i] != q[i - 1] && i > 1 && p[i - 2] == -1)
                {
                    p[i - 2] = q[i - 1];
                    used[p[i - 2]] = 1;
                    v.push_back(i - 2);
                }
            }
        }

        updated.clear();
        sz = v.size();
        for (int i = 0; i < sz; ++i)
            updated.push_back(v[i]);
    }

    //print();

    /// nope
    int l = 0;
    vector <int> seq;

    for (int i = 1; i <= n; i += 2)
    {
        if (p[i - 1] == -1 && p[i + 1] == -1)
        {
            ++l;
            used[q[i]] = 1;
        }
        else
        {
            if (l > 0)
                seq.push_back(l);
            l = 0;
        }
    }

    if (l > 0)
        seq.push_back(l);

    l = 0;
    for (int i = 2; i <= n; i += 2)
    {
        if (p[i - 1] == -1 && p[i + 1] == -1)
        {
            ++l;
            used[q[i]] = 1;
        }
        else
        {
            if (l > 0)
                seq.push_back(l);
            l = 0;
        }
    }

    if (l > 0)
        seq.push_back(l);

    int unused = 0;
    for (int i = 1; i <= n; ++i)
        if (used[i] == -1)
            ++unused;

    // unused = sequences count

    int sz = seq.size();
    ll ans = 1;

    for (int i = 0; i < sz; ++i)
        ans = (1LL * (seq[i] + 1) * ans) % MOD;

    ll fact = 1;
    for (int i = 2; i <= unused; ++i)
        fact = (1LL * i * fact) % MOD;

    ans = (ans * fact) % MOD;

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
