#include <bits/stdc++.h>
#define MAXN 1000005
#define MOD 1000000007
#define endl '\n'
using namespace std;
typedef long long ll;
int n;
int p[MAXN];
int q[MAXN];
int temp[MAXN];
bool used[MAXN];
vector <int> perm;
ll ans = 0;

void input()
{
    cin >> n;
    for (int i = 1; i <= n; ++i)
    {
        p[i] = -1;
        temp[i] = -1;
        cin >> q[i];
    }

    p[0] = MAXN;
    temp[0] = MAXN;
    p[n + 1] = MAXN;
    temp[n + 1] = MAXN;
    p[2] = q[1];
    temp[2] = q[1];
    p[n - 1] = q[n];
    temp[n - 1] = q[n];
    used[q[1]] = 1;
    used[q[n]] = 1;
}

bool check()
{
//    for (int i = 0; i < n; ++i)
//        cout << perm[i] << " ";
//    cout << endl;

    for (int i = 1; i <= n; ++i)
    {
        if (q[i] != perm[i + 1 - 1] && q[i] != perm[i - 1 - 1])
            return false;
    }

    return true;
}

void solve()
{
    for (int i = 1; i <= n; ++i)
        perm.push_back(i);

    ans = 0;

    while (next_permutation(perm.begin(), perm.end()))
    {
        if (check())
        {
            ++ans;
            ans %= MOD;
        }
    }

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
