#include <bits/stdc++.h>
#define endl '\n'
#define MOD 1000000007
#define MAXN 10003
using namespace std;
typedef long long ll;
ll n, m, k, a, b;
ll cnt_x[MAXN][MAXN];
ll cnt_y[MAXN][MAXN];

void input()
{
    cin >> n >> m >> a >> b >> k;
}

void solve()
{
    cnt_x[0][0] = 1;
    for (int moves = 1; moves <= k; ++moves)
        for (int dist = 0; dist <= n; ++dist)
        {
            cnt_x[dist][moves] = 0;
            for (int x = 0; x <= a; ++x)
            {
                if (dist >= x)
                {
                    cnt_x[dist][moves] += cnt_x[dist - x][moves - 1];
                    cnt_x[dist][moves] %= MOD;
                }
            }

            cout << dist << " - " << moves << ": " << cnt_x[dist][moves] << endl;
        }

    cnt_y[0][0] = 1;
    for (int moves = 1; moves <= k; ++moves)
        for (int dist = 0; dist <= m; ++dist)
        {
            cnt_y[dist][moves] = 0;
            for (int x = 0; x <= b; ++x)
            {
                if (dist >= x)
                {
                    cnt_y[dist][moves] += cnt_y[dist - x][moves - 1];
                    cnt_y[dist][moves] %= MOD;
                }
            }
        }

    cout << (cnt_x[n][k] * cnt_y[m][k]) % MOD << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
