#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 2003
#define MAXV 5003
#define INF 1000000003
using namespace std;
int n, m;
int s = 1, t;
int dist[MAXN];
bool used[MAXN];

struct node
{
    int ver, weight;

    node (int _ver, int _weight)
    {
        ver = _ver;
        weight = _weight;
    }

    bool operator < (const node &p) const
    {
        return p.weight < weight;
    }
};

vector <node> adj[MAXN];

void input()
{
    cin >> n >> m;
    t = n;

    for (int i = 0; i < m; ++i)
    {
        int from, to, weight, magic;
        cin >> from >> to >> weight >> magic;

        adj[from].push_back(node (to, weight));
    }
}

void diikstra()
{
    priority_queue<node> q;
    for (int i = 1; i <= n; ++i)
    {
        used[i] = 0;
        dist[i] = INF;
    }
    dist[s] = 0;
    q.push(node(s, 0));

    while (!q.empty())
    {
        node tmp = q.top();
        q.pop();

        if (dist[tmp.ver] >= tmp.weight && !used[tmp.ver])
        {
            used[tmp.ver] = 1;
            for (int i = 0; i < adj[tmp.ver].size(); ++i)
            {
                node nb = adj[tmp.ver][i];
                if (tmp.weight + nb.weight < dist[nb.ver])
                {
                    dist[nb.ver] = nb.weight + tmp.weight;
                    nb.weight = dist[nb.ver];
                    q.push(nb);
                }
            }
        }
    }

    if (dist[t] == INF)
    {
        cout << -1 << endl;
        return;
    }
    cout << dist[t] << endl;
}

void solve()
{
    diikstra();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
