#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
struct edge
{
    int from;
    int to;
    int cost;
    int gain;
};
bool cmp(edge a, edge b)
{
    if(a.to < b.to)
        return true;
    if(a.to > b.to)
        return false;
    if(a.from < b.from)
        return true;
    if(a.from > b.from)
        return false;
    return false;
}
vector<edge> edges;
int n, m;
int minDistance[110];
void Input()
{
    cin>>n>>m;
    int a,b,c,d;
    for(int i = 0; i < m; ++i)
    {
        cin>>a>>b>>c>>d;
        minDistance[b] = -1;
        edge temp;
        temp.from = a;
        temp.to = b;
        temp.cost = c;
        temp.gain = d;
        edges.push_back(temp);
    }
    sort(edges.begin(), edges.end(), cmp);
}
int main()
{
    Input();
    minDistance[0] = 0;
    for(auto temp : edges)
    {
        if(minDistance[temp.to] == -1){
            minDistance[temp.to] = minDistance[temp.from] + temp.cost;
        }
        else{
            minDistance[temp.to] = min(minDistance[temp.from] + temp.cost, minDistance[temp.to]);
        }
    }
    cout<<minDistance[n]<<endl;
    return 0;
}