#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const ll MOD = 1e9 + 7;

ll n, sz = 0, cnt = 0;
vector<int> Q, P, used, structs;
matrix<int> freq, G;

void dfs(int u){
	used[u] = true;
	++ sz;
	for(auto v : G[u]) if(!used[v]){
		dfs(v);
	}
}

int main(){
	cin >> n;
	used = P = Q = vector<int>(n);
	G = freq = matrix<int>(n + 1);
	for(auto &x : Q) cin >> x;
	/// check frequencies
	for(int i = 0; i < n; i ++){
		freq[Q[i]].pb(i);
	}
	for(int i = 1; i <= n; i ++){
		if(freq[i].size() > 2){ cout << "0\n"; return 0; }
		if(freq[i].size() == 2 && abs(freq[i][0] - freq[i][1]) != 2){ cout << "0\n"; return 0; }
	}
	P[1] = Q[0]; P[n - 2] = Q[n - 1];
	/// put 1, 3, 5...
	for(int i = 2; i < n; i += 2){
		if(Q[i] != P[i - 1] && i + 1 < n){
			P[i + 1] = Q[i];
		}
	}
	/// put n - 2, n - 4, n - 6...
	for(int i = n - 3; i >= 0; i -= 2){
		if(Q[i] != P[i + 1] && i - 1 >= 0){
			if(P[i - 1] == 0){
				P[i - 1] = Q[i];
			}
			else if(P[i - 1] != Q[i]){ cout << "0\n"; return 0; }
		}
	}
	/// put when Q[i - 1] = Q[i + 1]
	for(int i = 1; i < n - 1; i ++){
		if(Q[i - 1] == Q[i + 1]){
			if(P[i] == 0){
				P[i] = Q[i - 1];
			}
			else if(P[i] != Q[i - 1]){ cout << "0\n"; return 0; }
		}
	}
	for(int i = 2; i < n; i ++){
		if(!P[i - 2] && !P[i]){
			G[i].pb(i - 2);
			G[i - 2].pb(i);
		}
	}
	ll ans = 1;
	for(int u = 0; u < n; u ++){
		if(!used[u] && !P[u]){
			sz = 0;
			dfs(u);
			++ cnt;
			ans = (ans * sz) % MOD;
		}
	}
	cout << (ans * cnt) % MOD << endl;
}
/**
5
1 3 1 4 2
3

4
3 1 2 3
0
*/