#include<bits/stdc++.h>
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
#define ll long long
#define fr first
#define sc second
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int n, m;
matrix<pair<int, int>> G;

int main(){
	cin >> n >> m;
	G = matrix<pair<int, int>>(n + 1);
	for(int i = 0; i < m; i ++){
		int a, b, c, d; cin >> a >> b >> c >> d;
		G[a].pb({b, c});
		G[b].pb({a, c});
	}
	queue<int> q;
	vector<int> dist(n + 1, 1e9);
	q.push(1);
	dist[1] = 0;
	while(!q.empty()){
		auto u = q.front();
		q.pop();
		for(auto [v, w] : G[u]){
			if(dist[v] > dist[u] + w){
				dist[v] = dist[u] + w;
				q.push(v);
			}
		}
	}
	cout << dist[n] << endl;
}
/**
6 7 
1 2 1 0
2 4 1 0
4 6 5 0 
2 5 2 0 
1 3 3 0 
3 5 4 0 
5 6 2 0 

*/