#include<bits/stdc++.h>
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
#define ll long long
#define fr first
#define sc second
using namespace std;

template<class T> using matrix = vector<vector<T>>;



int main(){
	int n, m; cin >> n >> m;
	matrix<pair<int, int>> G(n + 1);
	for(int i = 0; i < m; i ++){
		int a, b, c, d; cin >> a >> b >> c >> d;
		G[a].pb({b, c});
		G[b].pb({a, c});
	}
	priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> pq;
	vector<int> dist(n + 1, 1e9), used(n + 1, false);
	pq.push({0, 1});
	dist[1] = 0;
	while(!pq.empty()){
		auto u = pq.top().sc;
		pq.pop();
		if(!used[u]){
			used[u] = true;
			for(auto [v, w] : G[u]){
				if(dist[v] > dist[u] + w){
					dist[v] = dist[u] + w;
					pq.push({dist[v], v});
				}
			}
		}
	}
	cout << (dist[n] == 1e9 ? -1 : dist[n]) << endl;
}
/**
6 7 
1 2 1 0
1 3 3 0
2 4 1 0
2 5 2 0
3 5 4 0
4 6 5 0
5 6 2 0
5
*/