#include<bits/stdc++.h>
using namespace std;

const int nmax=2e3+5;
const int magic_max=nmax*30;

int n,m;
vector< pair< int/*to*/,pair<int/*dist*/,int/*magic*/> > > adj[nmax];

long long magic_was[nmax];

priority_queue< pair<int/*dist*/, pair<int/*magic*/,int/*where*/> > > pq;

bool been[nmax];

void dfs(int node)
{
    if(been[node])return;

    been[node]=1;

    for(auto w:adj[node])
        dfs(w.first);
}

bitset<magic_max> dp[nmax];

vector< pair<int/*to*/,int/*dist*/> > trav[nmax];

int dij[nmax];

priority_queue< pair<int/*dist*/,int/*node*/> > dij_bck;

void bck()
{
    memset(dij,-1,sizeof(dij));

    dij_bck.push({0,n});

    while(dij_bck.size())
    {
        pair<int/*dist*/,int/*node*/> tp=dij_bck.top();
        dij_bck.pop();

        int dist=-tp.first;
        int node=tp.second;

        if(dij[node]!=-1)continue;

        dij[node]=node;

        for(auto w:trav[node])
            dij_bck.push({-(dist+w.first),w.second});
    }
}

int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=n;i++)magic_was[i]=-1;

    for(int i=1;i<=m;i++)
    {
        int a,b,c,d;

        scanf("%i%i%i%i",&a,&b,&c,&d);

        adj[a].push_back({b,{c,d}});

        trav[b].push_back({a,c});
    }

    bck();

    /*
    for(int i=1;i<=n;i++)
        cout<<dij[i]<<" ";cout<<endl;
    */

    if(dij[1]==-1)
    {
        printf("-1\n");
        return 0;
    }

    pq.push({0,{0,1}});

    while(pq.size())
    {
        pair<int/*dist*/, pair<int/*magic*/,int/*where*/> > tp=pq.top();

        pq.pop();

        int dist=-tp.first;
        int magic=tp.second.first;
        int node=tp.second.second;

        if(dij[node]==-1)continue;

        if(node==n||magic>=dij[node])
        {
            printf("%i\n",dist);
            exit(0);
        }

        if(dp[node][magic])continue;

        dp[node][magic]=1;

        for(auto w:adj[node])
        {
            int save=min(w.second.first,magic);

            int dist_now=dist+w.second.first-save;

            int magic_now=magic-save+w.second.second;

            int node_now=w.first;

            pq.push({-dist_now,{magic_now,node_now}});
        }
    }

    return 0;
}
