#include <bits/stdc++.h>

#define ENDL '\n'

namespace {
using num = long long;

template <class T>
using vec = std::vector<T>;

const num mod = 1e9 + 7;

auto solve(vec<num> const& q) {
    num res = 0;

    vec<num> p(q.size());
    std::iota(p.begin(), p.end(), 1);
    
    do {
        auto is_valid = true;
        for (auto idx = 0; idx < q.size(); ++idx) {
            auto is_curr_valid = false;

            if (idx > 0 && p[idx - 1] == q[idx]) {
                is_curr_valid = true;
            }

            if (idx < q.size() && p[idx + 1] == q[idx]) {
                is_curr_valid = true;
            }

            if (!is_curr_valid) {
                is_valid = false;

                break;
            }
        }

        if (is_valid) {
            res = (res + 1) % mod;
        }
    } while (std::next_permutation(p.begin(), p.end()));

    return res;
}
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    num n;
    std::cin >> n;

    vec<num> q(n);  
    for (auto& val : q) {
        std::cin >> val;
    }

    std::cout << solve(q) << ENDL;
    
    return 0;
}
