#include<iostream>
#include<cmath>
using namespace std;
const long long MOD=1000000007;
int N,M,A,B,K;
int time(int x,int y)
{ return 1+max(x/(A+1),y/(B+1)); }
long long F(int n,int m,int k)
{
	if(n==0&&m==0)return 1LL;
	if(k<time(n,m))return 0LL;
	if(k==1&&time(n,m)==1)return 1LL;
	long long res=0LL;
	int x0,y0,x1,y1;
	if(k&1LL)
	{
		k>>=1;
		x0=max(0,N-A*(k+1));
		x1=min(A*k,n);
		y0=max(0,M-B*(k+1));
		y1=min(B*k,m);
		for(int i=x0;i<=x1;i++)
			for(int j=y0;j<=y1;j++)
				res=(res+(F(n-i,m-j,k+1)*F(i,j,k))%MOD)%MOD;
	}
	else
	{
		k>>=1;
		x0=max(0,n-A*k);
		x1=min(A*k,n);
		y0=max(0,m-B*k);
		y1=min(B*k,m);
		for(int i=x0;i<=x1;i++)
			for(int j=y0;j<=y1;j++)
				res=(res+(F(i,j,k)*F(n-i,m-j,k))%MOD)%MOD;
	}
	return res;
}
int main()
{
	cin>>N>>M>>A>>B>>K;
	cout<<time(N,M)<<endl;
	cout<<F(N,M,K)<<endl;

	return 0;
}
/*
3 1 2 3 2
*/
/*
100 100 30 30 10
*/