#include <bits/stdc++.h>
using namespace std;
int n, m, a, b, c, d;
int const inf = 999999999;
vector<vector<pair<int,int> > > adj;
vector<int>dist;
void dijkstra(int vertex)
{
    vector<bool> used;
    used.assign(n, 0);
    dist.assign(n, inf);
    dist[vertex] = 0;
    used[vertex] = 1;
    for(int i=0; i<adj[vertex].size(); i++)
    {
        int v = -1;
        for(int j=0; j<adj[vertex].size(); j++)
        {
            if(!used[j]&&(v==-1||dist[j]<dist[v])) v = j;
        }
        if(dist[v]==inf) break;
        used[v] = 1;
        for(auto edge: adj[v])
        {
            int x = edge.first;
            int len = edge.second;
            if(dist[v]+len<dist[x]) dist[x]=dist[v]+len;
        }
    }
    return;
}
int main()
{
    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        cin>>a>>b>>c>>d;
        adj[a].push_back({b, c});
    }
    dijkstra(1);
    cout<<dist[n]<<endl;
    return 0;
}
