#include <bits/stdc++.h>
using namespace std;

int n, m, a, b, c, d;
int const inf = 999999999;
vector<pair<int, int> >vec[101];
priority_queue<pair<int, int> > q;
long long dist[101];
bool visited[101];

void dijkstra(int vertex)
{
    int tp;
    fill_n(dist, 101, inf);
    dist[vertex] = 0;
    q.push({0, vertex});
    while(!q.empty())
    {
        tp = q.top().second;
        q.pop();
        if(visited[tp]) continue;
        visited[tp]=1;
        for(int i=0; i<vec[tp].size(); i++)
        {
            pair<int, int> ch = vec[tp][i];
            if(dist[ch.second]>dist[tp]+ch.first)
            {
                dist[ch.second]=dist[tp]+ch.first;
                q.push({-dist[ch.second], ch.second});
            }
        }
    }
    return;
}
int main()
{
    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        cin>>a>>b>>c>>d;
        vec[a].push_back({c, b});
    }
    dijkstra(1);
    cout<<dist[n]<<endl;
    return 0;
}

