#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#define endl '\n'

using namespace std;

typedef unsigned short us;

const us maxn = 2003; 
const us maxmagic = 60003; 
const us inf = 60003; 

struct road {
    us to, dist, magic;
    road(us to, us dist, us magic) {
        this->to = to;
        this->dist = dist;
        this->magic = magic;
    }
};

us n, m; 
vector <road> adj[maxn];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        us a, b, c, d;
        cin >> a >> b >> c >> d;
        
        adj[a].push_back(road(b, c, d));
    }
}

us cost[maxn][maxmagic];
vector <pair <us, us> > pq[32];
us dijkstra() {
    for (int i = 1; i <= n; i++)
    for (int j = 0; j <= n * 30; j++)
    cost[i][j] = inf;
    
    pq[0].push_back({1, 0});
    cost[1][0] = 0;
    for (int i = 0; i <= n * 30; ) {
        if (pq[0].empty()) {
            for (int i = 1; i <= 31; i++)
            swap(pq[i], pq[i-1]);
            
            i++;
            continue;
        }
        
        pair <us, us> node = pq[0].back();
        pq[0].pop_back();
        if (node.first == n)
        return i;
        
        if (i != cost[node.first][node.second])
        continue;
        
        for (auto e: adj[node.first]) {
            if (node.second >= e.dist && (int)node.second - (int)e.dist + (int)e.magic <= n * 30) {
                if (cost[e.to][node.second - e.dist + e.magic] > i) {
                    cost[e.to][node.second - e.dist + e.magic] = i;
                    pq[0].push_back({e.to, node.second - e.dist + e.magic});
                }
            }
            
            else {
                if (cost[e.to][e.magic] > i + e.dist - node.second) {
                    cost[e.to][e.magic] = i + e.dist - node.second;
                    pq[e.dist - node.second].push_back({e.to, e.magic});
                }
            }
        }		
    }
    
    return -1;
}

void solve()
{
    cout << dijkstra() << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    read();
    solve();
}
