#include<iostream>

using namespace std;

const int maxN = 10005;
const int maxM = 10005;
const int mod = 1000000007;

long long ans1[2][maxN];
long long ans2[2][maxM];

int main(){
    int n, m, a, b, k;
    cin >> n >> m >> a >> b >> k;

    for(int i=1; i<=n; i++){
        if(i <= a) ans1[1][i] = 1;
        else ans1[1][i] = 0;
    }
    for(int i=1; i<=m; i++){
        if(i <= b) ans2[1][i] = 1;
        else ans2[1][i] = 0;
    }

    for(int i=0; i<=1; i++){
        ans1[i][0] = 1;
        ans2[i][0] = 1;
    }

    for(int i=2; i<=k; i++){
        for(int j=1; j<=n; j++){
            ans1[i%2][j] = ans1[i%2][j-1] + ans1[(i-1)%2][j];
            if (a < j) ans1[i%2][j] -= ans1[(i-1)%2][j-1-a];
            ans1[i%2][j] %= mod;
        }
        for(int j=1; j<=m; j++){
            ans2[i%2][j] = ans2[i%2][j-1] + ans2[(i-1)%2][j];
            if (b < j) ans2[i%2][j] -= ans2[(i-1)%2][j-1-b];
            ans2[i%2][j] %= mod;
        }
    }

    long long answer = (ans1[k%2][n] * ans2[k%2][m]) % mod;
    cout << answer << endl;

    return 0;
}
