#pragma GCC optimize ("O3")
#include <iostream>
#include <stack>
#define endl '\n'
using namespace std;

int b[6];
stack<int> s1, s2;
int record;

void input() {
    for (int i = 1; i <= 5; i++) {
        cin >> b[i];
    }
}

bool zero(int n, int arr[]) {
    int sum = 0;
    for (int i = 1; i <= n; i++) {
        sum += arr[i];
    }
    return sum == 0;
}

void pushHigh(stack<int>& s) {
    for (int i = 5; i >= 1; i--) {
        if (b[i] != 0) {
            s.push(i);
            b[i]--;
            break;
        }
    }
}

void pushLow(stack<int>& s) {
    for (int i = 1; i <= 5; i++) {
        if (b[i] != 0) {
            s.push(i);
            b[i]--;
            break;
        }
    }
}

void calcRecord(stack<int> s) {
    int top, val;
    while (s.size() > 1) {
        top = s.top(); s.pop();
        val = top - (5 - s.top());
        if (val < 0) val = 0;
        record += val;
    }
}

void solve() {
    bool high = true;
    while (!zero(5, b)) {
        if (high) {
            pushHigh(s1);
            pushHigh(s2);
            high = false;
        } else {
            pushLow(s1);
            pushLow(s2);
            high = true;
        }
    }
    int val = s1.top() - (5 - s2.top());
    if (val < 0) val = 0;
    record += val;
    calcRecord(s1);
    calcRecord(s2);
}

void output() {
    cout << record << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    input();
    solve();
    output();

    return 0;
}
