#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const ll MAX_N = 1e6 + 10;
pair<ll, ll> where[MAX_N];
ll n;
ll perm[MAX_N];
vector<ll> who[2];
bool oktopush[MAX_N];

ll solve() {
    for(ll i = 0; i < n; i ++) {
        if(where[perm[i]].first == -1) {
            where[perm[i]].first = i;
        } else if(where[perm[i]].second == -1) {
            where[perm[i]].second = i;
        } else {
            return 0;
        }
    }
    ll fact = 1;
    ll cnt = 1;
    for(ll i = 1; i <= n; i ++) {
        if(where[i].first == -1) {
            fact = (fact * cnt) % mod;
            cnt ++;
        } if(where[i].second != -1) {
            if(where[i].second - where[i].first != 2) {
               return 0;
            }
            oktopush[where[i].first] = true;
        }
    }

    for(ll i = 0; i < n; i ++) {
        if(oktopush[i]) {
            who[i & 1].push_back(i / 2);
        }
    }

    ll ret = 1;
    for(ll i = 0; i < who[0].size(); i ++) {
        if(i == who[0].size() - 1 && n % 2 == 0) {
            ret = (ret * ((n / 2 - who[0][i] - 1))) % mod;
        }
        if(i != 0) {
            ret = (ret * ((who[0][i] - who[0][i - 1] - 1))) % mod;
        }
    }

    for(ll i = 0; i < who[1].size(); i ++) {
        if(i == 0) {
            ret = (ret * ((who[1][i] + 1))) % mod;
        } 
        if(i == who[1].size() - 1 && n % 2 == 1) {
            ret = (ret * ((n / 2 - who[1][i] - 1))) % mod;
        }
        if(i != 0) {
            ret = (ret * ((who[1][i] - who[1][i - 1] - 1))) % mod;
        }
    }

    if(who[1].empty() && n % 2 == 1) {
        ret = (ret * (n / 2 + 1)) % mod;
    }
    if(who[0].empty() && n % 2 == 1) {
        ret = 0;
    }

    return (ret * fact) % mod;
}

signed main() {
    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL); std::cout.tie(NULL);    

    cin >> n;
    for(ll i = 0; i < n; i ++) {
        cin >> perm[i];
        where[i] = {-1, -1};
    }
    where[n] = {-1, -1};
    cout << solve();
    return 0;

    return 0;
}