#include <bits/stdc++.h>
#pragma GCC target("sse4")
#pragma GCC optimize("O3")
#ifndef LOCAL
#define cerr if(false) cerr
#endif
typedef long long ll;
template<class T, class T2> inline std::ostream &operator <<(std::ostream &out, const std::pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const ll MAX_N = 2010, MAX_M = 5010, MAX_K = MAX_N * 30;
int dp[MAX_N][MAX_K];
ll n, m;

struct wow {
    ll first;
    std::pair<ll, ll> second;
};

std::vector<wow> g[MAX_N]; 

bool operator <(const wow &a, const wow &b) {
    if(a.first != b.first) {
        return a.first < b.first;
    } else {
        return a.second.second > b.second.second;
    }
}

ll dij() {
    for(ll i = 0; i < MAX_N; i ++) {
        for(ll j = 0; j < MAX_K; j ++) {
            dp[i][j] = mod;
        }
    }

    std::priority_queue<wow> pq;
    pq.push({0, {1, 0}});

    ll ret = mod;

    while(!pq.empty()) {
        auto curr = pq.top(); pq.pop();
        curr.first *= -1;

        if(curr.first > dp[curr.second.first][curr.second.second]) {continue;}

        for(const auto &it : g[curr.second.first]) {
            wow trans = {curr.first + std::max(0ll, it.second.first - curr.second.second), 
                                                         {it.first, std::max(0ll, curr.second.second - it.second.first) + it.second.second}};
            if(trans.second.second >= MAX_K) {trans.second.second = MAX_K - 1;}
            if(dp[trans.second.first][trans.second.second] > trans.first) {
                dp[trans.second.first][trans.second.second] = trans.first;
                trans.first *= -1;
                pq.push(trans);
            }
        }

        if(curr.second.first == n) {
            chkmin(ret, curr.first);
        }
    }

    if(ret == mod) {
        return -1;
    }
    return ret;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif

    std::cin >> n >> m;
    for(ll i = 0; i < m; i ++) {
        ll a, b, c, d;
        std::cin >> a >> b >> c >> d;
        g[a].push_back({b, {c, d}});
    }

    std::cout << dij() << std::endl;

    return 0;
}
