#include<iostream>
using namespace std;

const long long mnogo = 1000000007;

long long kraenX;
long long kraenY;

long long skokPoX;
long long skokPoY;

long long zaKolkoSekundi;

long long priTolkova[305][305][2];

long long brNachiniDoNachaloOtZa(long long otX, long long otY, long long zaSekundi){
    if(zaSekundi == 0){
        if(otX == 0 && otY == 0){
            return 1;
        }else{
            return 0;
        }
    }

    if(otX == 0 && otY == 0){
        return 1;
    }

    if(priTolkova[otX][otY][zaSekundi] > -1){
        return priTolkova[otX][otY][zaSekundi];
    }

    long long zaTuka = 0;

    for(long long promqnaVX = 0; promqnaVX <= min(skokPoX, otX); promqnaVX++){
        for(long long promqnaVY = 0; promqnaVY <= min(skokPoY, otY); promqnaVY++){
            zaTuka = (zaTuka + brNachiniDoNachaloOtZa(otX - promqnaVX, otY - promqnaVY, zaSekundi - 1))%mnogo;
        }
    }

    priTolkova[otX][otY][zaSekundi] = zaTuka;
    return zaTuka;
}

long long sCycli(long long zaOtX, long long zaOtY, long long zaZaSekundi){
    priTolkova[0][0][0] = 1;

    for(long long zaSekundi = 1; zaSekundi <= zaZaSekundi; zaSekundi++){
        for(long long otX = 0; otX <= zaOtX; otX++){
            for(long long otY = 0; otY <= zaOtY; otY++){
                long long zaTuka = 0;

                for(long long promqnaVX = 0; promqnaVX <= min(skokPoX, otX); promqnaVX++){
                    for(long long promqnaVY = 0; promqnaVY <= min(skokPoY, otY); promqnaVY++){
                        zaTuka = (zaTuka + priTolkova[otX - promqnaVX][otY - promqnaVY][(zaSekundi - 1)%2])%mnogo;
                    }
                }

                priTolkova[otX][otY][zaSekundi%2] = zaTuka;
            }
        }
    }

    return priTolkova[zaOtX][zaOtY][zaZaSekundi%2];
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>kraenX>>kraenY>>skokPoX>>skokPoY>>zaKolkoSekundi;

    /*for(int i = 0; i <= kraenX; i++){
        for(int y = 0; y <= kraenY; y++){
            for(int k = 0; k <= zaKolkoSekundi; k++){
                priTolkova[i][y][k] = -1;
            }
        }
    }

    int otgovor = brNachiniDoNachaloOtZa(kraenX, kraenY, zaKolkoSekundi);*/
    int otgovor = sCycli(kraenX, kraenY, zaKolkoSekundi);

    cout<<otgovor<<endl;

    return 0;
}
