#include<iostream>
using namespace std;

const long long mnogo = 1000000007;

long long kraenX;
long long kraenY;

long long skokPoX;
long long skokPoY;

long long zaKolkoSekundi;

long long brVazmojnostiZaX(long long otX, long long zaSekundi){
    if(zaSekundi == 0){
        if(otX == 0){
            return 1;
        }else{
            return 0;
        }
    }

    long long zaTuka = 0;

    for(long long promqnaPoX = 0; promqnaPoX <= min(skokPoX, otX); promqnaPoX++){
        zaTuka = (zaTuka + brVazmojnostiZaX(otX - promqnaPoX, zaSekundi - 1))%mnogo;
    }

    return zaTuka;
}

long long brVazmojnostiZaY(long long otY, long long zaSekundi){
    if(zaSekundi == 0){
        if(otY == 0){
            return 1;
        }else{
            return 0;
        }
    }

    long long zaTuka = 0;

    for(long long promqnaPoY = 0; promqnaPoY <= min(skokPoY, otY); promqnaPoY++){
        zaTuka = (zaTuka + brVazmojnostiZaY(otY - promqnaPoY, zaSekundi - 1))%mnogo;
    }

    return zaTuka;
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>kraenX>>kraenY>>skokPoX>>skokPoY>>zaKolkoSekundi;

    long long broiNachiniZaX = brVazmojnostiZaX(kraenX, zaKolkoSekundi);
    long long broiNachiniZaY = brVazmojnostiZaY(kraenY, zaKolkoSekundi);

    long long otgovor = (broiNachiniZaX*broiNachiniZaY)%mnogo;

    cout<<otgovor<<endl;

    return 0;
}
