#include<iostream>
using namespace std;

const long long mnogo = 1000000007;

long long kraenX;
long long kraenY;

long long skokPoX;
long long skokPoY;

long long zaKolkoSekundi;

long long priTolkovaX[1024][1024];

long long brVazmojnostiZaX(long long otX, long long zaSekundi){
    if(zaSekundi == 0){
        if(otX == 0){
            return 1;
        }else{
            return 0;
        }
    }

    if(priTolkovaX[otX][zaSekundi] > -1){
        return priTolkovaX[otX][zaSekundi];
    }

    long long zaTuka = 0;

    for(long long promqnaPoX = 0; promqnaPoX <= min(skokPoX, otX); promqnaPoX++){
        zaTuka = (zaTuka + brVazmojnostiZaX(otX - promqnaPoX, zaSekundi - 1))%mnogo;
    }

    priTolkovaX[otX][zaSekundi] = zaTuka;
    return zaTuka;
}

long long priTolkovaY[1024][1024];

long long brVazmojnostiZaY(long long otY, long long zaSekundi){
    if(zaSekundi == 0){
        if(otY == 0){
            return 1;
        }else{
            return 0;
        }
    }

    if(priTolkovaY[otY][zaSekundi] > -1){
        return priTolkovaY[otY][zaSekundi];
    }

    long long zaTuka = 0;

    for(long long promqnaPoY = 0; promqnaPoY <= min(skokPoY, otY); promqnaPoY++){
        zaTuka = (zaTuka + brVazmojnostiZaY(otY - promqnaPoY, zaSekundi - 1))%mnogo;
    }

    priTolkovaY[otY][zaSekundi] = zaTuka;
    return zaTuka;
}

long long sCycliX(long long zaOtX, long long zaZaSekundi){
    priTolkovaX[0][0] = 1;

    for(long long zaSekundi = 1; zaSekundi <= zaZaSekundi; zaSekundi++){
        for(long long otX = 0; otX <= zaOtX; otX++){
            long long zaTuka = 0;

            for(long long promqnaPoX = 0; promqnaPoX <= min(skokPoX, otX); promqnaPoX++){
                zaTuka = (zaTuka + priTolkovaX[otX - promqnaPoX][zaSekundi - 1])%mnogo;
            }

            priTolkovaX[otX][zaSekundi] = zaTuka;
        }
    }

    return priTolkovaX[zaOtX][zaZaSekundi];
}

long long sCycliY(long long zaOtY, long long zaZaSekundi){
    priTolkovaY[0][0] = 1;

    for(long long zaSekundi = 1; zaSekundi <= zaZaSekundi; zaSekundi++){
        for(long long otY = 0; otY <= zaOtY; otY++){
            long long zaTuka = 0;

            for(long long promqnaPoY = 0; promqnaPoY <= min(skokPoY, otY); promqnaPoY++){
                zaTuka = (zaTuka + priTolkovaY[otY - promqnaPoY][zaSekundi - 1])%mnogo;
            }

            priTolkovaY[otY][zaSekundi] = zaTuka;
        }
    }

    return priTolkovaY[zaOtY][zaZaSekundi];
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>kraenX>>kraenY>>skokPoX>>skokPoY>>zaKolkoSekundi;

    /*for(long long x = 0; x <= kraenX; x++){
        for(long long i = 0; i <= zaKolkoSekundi; i++){
            priTolkovaX[x][i] = -1;
        }
    }

    for(long long y = 0; y <= kraenY; y++){
        for(long long i = 0; i <= zaKolkoSekundi; i++){
            priTolkovaY[y][i] = -1;
        }
    }*/

    //long long broiNachiniZaX = brVazmojnostiZaX(kraenX, zaKolkoSekundi);
    //long long broiNachiniZaY = brVazmojnostiZaY(kraenY, zaKolkoSekundi);

    long long broiNachiniZaX = sCycliX(kraenX, zaKolkoSekundi);
    long long broiNachiniZaY = sCycliY(kraenY, zaKolkoSekundi);

    long long otgovor = (broiNachiniZaX*broiNachiniZaY)%mnogo;

    cout<<otgovor<<endl;

    return 0;
}
