#include <bits/stdc++.h>
using namespace std;

const int V = 2000;

int calc_path(int u, int n, pair<int, int> graph[][V], bool visited[]){
	if(u == n){
		return 0;
	}
	visited[u] = true;
	int ans = INT_MAX;
	for(int i = 1; i <= n; i ++){
		if(graph[u][i].first != -1 && !visited[i]){
			int curr = calc_path(i, n, graph, visited);

			
			if(curr < INT_MAX){
				ans = min(ans, graph[u][i].first + curr);
			}
		}
	}
	visited[u] = false;
	return ans;
}

void inp(){
	int n, m;
	cin >> n >> m;
	pair<int, int> graph[n+1][V];
	for(int i = 1; i <= n; i++){
		for(int j = 1; j <= n; j++){
			graph[i][j].first = -1;
		}
	}
	for(int i = 0 ; i < m; i++){
		int a, b, d, w;
		cin >> a >> b >> d >> w;
		graph[a][b] = make_pair(d, w);
		graph[b][a] = make_pair(d, w);
	}

	bool visited[n+1] {0};
	visited[1] = 1;
	cout << calc_path(1, n, graph, visited);
}

int main(){
	//cout << INT_MAX;
	inp();
}