#include<bits/stdc++.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("avx2")
#define endl "\n"

using namespace std;

struct edge
{
    int sum, k1, k2, k3, k4, k5;
    edge() { }
    edge(int sum, int k1, int k2, int k3, int k4, int k5) :sum(sum), k1(k1), k2(k2), k3(k3), k4(k4), k5(k5) { }
};

const int N = 10010, inf = 1e9;
edge dp[N][32];

int ones(int x)
{
    int ans = 0;
    while(x)
    {
        if(x % 2) ans++;
        x /= 2;
    }
    return ans;
}

int compares(int a, int b)
{
    int ans = 0;
    string s1 = "", s2 = "";
    while(a)
    {
        if(a % 2) s1 += "1";
        else s1 += "0";
        a /= 2;
    }
    while(b)
    {
        if(b % 2) s2 += "1";
        else s2 += "0";
        b /= 2;
    }
    for(int i = 0; i < 5; ++i) if(s1[i] == '1' && s2[i] == '1') ans++;
    return ans;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    //cout.tie(NULL);

    int k[8], cnt = 0, pos = 0, n = 0;
    string s[10010];
    for(int i = 1; i <= 5; ++i) cin >> k[i], n += k[i];

    for(int i = 1; i <= n; ++i)
        for(int j = 1; j < 32; ++j) dp[i][j].sum = inf;
    for(int i = 1; i < 32; ++i)
    {
        int d = ones(i);
        if(d == 1) dp[1][i] = {0, k[1] - 1, k[2], k[3], k[4], k[5]};
        else if(d == 2) dp[1][i] = {0, k[1], k[2] - 1, k[3], k[4], k[5]};
        else if(d == 3) dp[1][i] = {0, k[1], k[2], k[3] - 1, k[4], k[5]};
        else if(d == 4) dp[1][i] = {0, k[1], k[2], k[3], k[4] - 1, k[5]};
        else dp[1][i] = {0, k[1], k[2], k[3], k[4], k[5] - 1};
    }
    for(int i = 2; i <= n; ++i)
    {
        for(int j = 1; j < 32; ++j)
        {
            for(int k = 1; k < 32; ++k)
            {
                int g = compares(j, k);
                //cout << i << " " << j << " " << k << " " << g << endl;
                int d = ones(j);
                if(d == 1)
                {
                    if(dp[i - 1][k].k1 == 0) continue;
                }
                else if(d == 2)
                {
                    if(dp[i - 1][k].k2 == 0) continue;
                }
                else if(d == 3)
                {
                    if(dp[i - 1][k].k3 == 0) continue;
                }
                else if(d == 4)
                {
                    if(dp[i - 1][k].k4 == 0) continue;
                }
                else if(d == 5)
                {
                    if(dp[i - 1][k].k5 == 0) continue;
                }
                if(dp[i - 1][k].sum + g < dp[i][j].sum)
                {
                    dp[i][j] = dp[i - 1][k];
                    dp[i][j].sum += g;

                    if(d == 1) dp[i][j].k1--;
                    else if(d == 2) dp[i][j].k2--;
                    else if(d == 3) dp[i][j].k3--;
                    else if(d == 4) dp[i][j].k4--;
                    else dp[i][j].k5--;
                }
            }
        }
    }
    /*for(int i = 1; i <= n; ++i, cout << endl)
        for(int j = 1; j < 32; ++j)
    {
        if(dp[i][j].sum == inf) cout << "- ";
        else cout << dp[i][j].sum << " ";
    }*/
    int ans = inf;
    for(int i = 1; i < 32; ++i) ans = min(ans, dp[n][i].sum);
    cout << ans << endl;
    return 0;
}
