#include<bits/stdc++.h>
using namespace std;
struct edge
{
    long long ver;
    long long path;
    long long magic;
    edge(){};
    edge( long long ver1, long long path1, long long magic1 )
    {
        ver = ver1;
        path = path1;
        magic = magic1;
    }
    bool operator < ( const edge & e ) const
    {
        return ( path > e.path );
    }
};
const long long maxn = 5005;
long long n,m;
vector<edge>v[maxn];
unsigned long long d[maxn];
void read()
{
    cin >> n >> m;
    for( long long i = 1; i <= m; i ++ )
    {
        long long a,b,x,y;
        cin >> a >> b >> x >> y;
        edge e(b,x,y);
        v[a].push_back(e);
    }
}
void dijkstra()
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    d[1] = 0;
    edge e(1,0,0);
    q.push(e);
    while( !q.empty() )
    {
        edge w = q.top();
        q.pop();
        if( w.path <= d[w.ver] )
        {
            long long sz = v[w.ver].size();
            for( long long i = 0; i < sz; i ++ )
            {
                edge nb = v[w.ver][i];
                if( nb.path + d[w.ver] < d[nb.ver] )
                {
                    nb.path += d[w.ver];
                    d[nb.ver] = nb.path;
                    q.push(nb);
                }
            }
        }
    }
    if( d[n] > 100000 ) cout << -1 << endl;
    else cout << d[n] << endl;
}
int main()
{
    read();
    dijkstra();
    return 0;
}
/*
5 5
1 3 4 0
1 4 10 0
3 2 1 0
4 5 0 0
2 5 0 0
*/
