#include <bits/stdc++.h>
using namespace std;
const int MAXN = 2001;
const unsigned int INF = 100000;
int n, m, used[MAXN], d[MAXN];
struct edge
{
    int ver;
    int dist;
    edge()
    {

    }
    edge(int ve, int di)
    {
        ver = ve;
        dist = di;
    }
    bool operator < (const edge &e)const
    {
        return dist > e.dist;
    }
};
vector<edge> v[MAXN];
void init()
{
    for(int i = 1; i <= n; i++)
    {
        d[i] = INF;
    }
}
void read()
{
    cin >> n >> m;
    int a, b, x, y;
    for(int i = 0; i < m; i++)
    {
        cin >> a >> b >> x >> y;
        v[a].push_back(edge(b, x));
    }
}
void dijkstra()
{
    priority_queue<edge> q;
    d[1] = 0;
    q.push(edge(1, 0));
    edge nb, w;
    int sz;
    while(!q.empty())
    {
        nb = q.top(); q.pop();
        sz = v[nb.ver].size();
        for(int i = 0; i < sz; i++)
        {
            w = v[nb.ver][i];
            if(d[w.ver] > d[nb.ver] + w.dist)
            {
                d[w.ver] = d[nb.ver] + w.dist;
                if(!used[w.ver])
                {
                    q.push(w);
                }
            }
        }
        used[nb.ver] = 1;
    }
}

int main()
{
    cout.tie(NULL);
    read();
    init();
    dijkstra();
    cout << d[n] << endl;
    return 0;
}
