#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int N;
vector<int> Q;

void read() {
    cin >> N;

    Q.resize(N);
    for (int &i : Q) {
        cin >> i;
    }
}

void solve() {
    int answer = 0;
    for (int mask = 0; mask < (1 << (N - 2)); mask++) {
        vector<int> perm(N, -1);
        bool ok = true;
        perm[1] = Q[0];
        perm[N - 2] = Q[N - 1];

        for (int i = 1; i < N - 1; i++) {
            if (mask & (1 << (i - 1))) {
                if (perm[i - 1] != -1 && perm[i - 1] != Q[i]) {
                    ok = false;
                    break;
                } else {
                    perm[i - 1] = Q[i];
                }
            } else {
                if (perm[i + 1] != -1 && perm[i + 1] != Q[i]) {
                    ok = false;
                    break;
                } else {
                    perm[i + 1] = Q[i];
                }
            }
        }

        set<int> s(perm.begin(), perm.end());
        ok = s.size() == N;

        answer += ok;
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
