#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int b[6];

void read() {
    for (int i = 1; i <= 5; i++) {
        cin >> b[i];
    }
}

int conflict(int a, int b) {
    return __builtin_popcount(a & b);
}

void solve() {
    int n = 0;
    for (int i = 1; i <= 5; i++) {
        n += b[i];
    }

    int minRecord = 1e9;
    for (int from = 1; from <= 32; from++) {
        int numBits = __builtin_popcount(from);

        if (!b[numBits]) {
            continue;
        }

        b[numBits]--;
        int currRecord = 0;
        vector<int> seq = {from};
        for (int i = 1; i < n; i++) {
            int minConflict = 1e9, next = -1;
            for (int j = 1; j <= 32; j++) {
                int numBits = __builtin_popcount(j);

                if (b[numBits]) {
                    int con = conflict(seq.back(), j);

                    if (con < minConflict) {
                        minConflict = con;
                        next = j;
                    }
                }
            }

            currRecord += minConflict;
            seq.emplace_back(next);
            b[__builtin_popcount(next)]--;
        }

        minRecord = min(minRecord, currRecord);

        for (int i : seq) {
            b[__builtin_popcount(i)]++;
        }
    }

    cout << minRecord << endl;
}

int main() {
    setIO();

    read();

    solve();
}
