# include <bits/stdc++.h>
using namespace std;
const long long MAXN = 1e4+5;
struct edge
{
    int u,v,dist,power;
};
vector <edge> g;
vector <edge> p[2005];
bool vis[MAXN],vis2[MAXN];
vector <int> h[2005];
int n;
int MAX(int A, int B)
{
    if(A > B)return A;
    return B;
}
void dfs(int v)
{
    vis2[v] = 1;
    for(auto u:h[v])
    {
        if(!vis2[u])dfs(u);
    }
}
priority_queue <pair <int , int> > q;
int maxs[2005];

bool check(int x)
{
    memset(maxs,-1,sizeof(maxs));
    memset(vis,0,sizeof(vis));
    maxs[1] = x;
    while(!q.empty())q.pop();
    q.push({x,1});
    int v;
    while(!q.empty())
    {
        v = q.top().second;
        if(q.top().first!=maxs[v]){q.pop();continue;}
        q.pop();
        vis[v] = 1;
       // cout<<x<<" "<<v<<" "<<maxs[v]<<endl;
        for(auto t:p[v])
        {
            if(maxs[v]>=t.dist && maxs[v]-t.dist + t.power > maxs[t.v])
            {
                if((vis[t.v]&&vis2[t.v])||(t.v==n)){return 1;}
                maxs[t.v] =  maxs[v]-t.dist + t.power;
                q.push({maxs[t.v],t.v});
            }
        }
    }
    return 0;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int m;
    cin>>n>>m;
    int a,b,c,d,i;
    for(i=1;i<=m;i++)
    {
        cin>>a>>b>>c>>d;
        edge w;
        w.u = a;
        w.v = b;
        w.dist = c;
        w.power = d;
        g.push_back(w);
        h[b].push_back(a);
        p[a].push_back(w);
    }
    dfs(n);
    if(n==1){cout<<0<<endl;return 0;}
    if(!vis2[1]){cout<<-1<<endl;return 0;}


    int t;
    int u,v;
    int uk1 = 0,uk2 = 60000,mid;
    while(uk1<uk2){
        mid = (uk1+uk2)/2;
        if(check(mid))
        {
            uk2 = mid;
        }
        else
            uk1 = mid+1;

    }

    cout<<uk2<<endl;
    return 0;
}
