#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include<bits/stdc++.h>
using namespace std;

const int n = 5;
int b[n + 1], res = 0, last = 0, sum = 0;

inline int col(int i, int j)
{ return max(i + j - n, 0); }

inline void check(int i, int j) //i > j
{
	if(b[i] && b[j])
	{
		if(col(last, i) > col(last, j))
			res += col(last, j) + col(j, i),
			b[j]--;
		else
			res += col(last, i);
		if(b[j])
		{
			if(b[j] >= b[i])
			{
				b[j] -= b[i];
				res += (1 + (b[i] - 1 << 1)) * col(i, j);
				b[i] = 0;
				last = j;
			}
			else
			{
				res += (b[j] << 1) * col(i, j);
				b[i] -= b[j] + 1;
				b[j] = 0;
				last = i;
			}
		}
	}
}
inline void same(int i)
{
	if(b[i])
		res += col(last, i),
		res += (b[i] - 1) * col(i, i),
		b[i] = 0;
}

int rec(int used = 0, int last = 0, int cols = 0)
{
	if(used == sum) return cols;
	int res = INT_MAX;
	for(int i = 1; i <= n; i++) if(b[i])
	{
		b[i]--;
		res = min(res, rec(used + 1, i, cols + col(last, i)));
		b[i]++;
	}
	return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

	for(int i = 1; i <= n; i++) cin >>b[i];
	/*
	check(5, 1);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	check(5, 2);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	check(5, 3);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	check(5, 4);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	same(5);
	cout <<"same:" <<endl;
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	cout <<"same:" <<endl;
	check(4, 1);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	check(4, 2);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	check(4, 3);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	same(4);
	cout <<"same:" <<endl;
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	cout <<"same:" <<endl;
	check(3, 1);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	check(3, 2);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	same(3);
	cout <<"same:" <<endl;
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	cout <<"same:" <<endl;
	check(2, 1);
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	same(2);
	cout <<"same:" <<endl;
	cout <<"b: "; for(int i = 1; i <= n; i++) cout <<b[i] <<" "; cout <<endl;
	cout <<"res: " <<res <<endl;
	cout <<"same:" <<endl;
	cout <<res <<endl;//*/
	/*
	check(5, 1);
	check(5, 2);
	check(5, 3);
	check(5, 4);
	same(5);
	check(4, 1);
	check(4, 2);
	check(4, 3);
	same(4);
	check(3, 1);
	check(3, 2);
	same(3);
	check(2, 1);
	same(2);
	cout <<res <<endl;//*/
	for(int i = 1; i <= n; i++) sum += b[i];
	cout <<rec() <<endl;
}
/*
3 1 4 2 1
11100 - 3
00111 - 3
11100 - 3
00011 - 2
11100 - 3
00001 - 1
11110 - 4
00001 - 1
11110 - 4
00001 - 1
11111 - 5
3

1 1 1 1 1
11100
00011
11110
00001
11111
2

3 1 1 1 1
11000
00001
11100
00001
11110
00001
11111
1

0 3 0 4 0
11110
00011
11110
00011
11110
00011
11110
6

0 1000 0 0 0
0 0 1000 0 0
0 0 0 0 1000
9999 0 0 0 10000

5 5 5 5 5
22

3 5 7 6 4
11100
00111
11100
00111
11100
00111
11110
00111
11110
00011
11110
00011
11110
00011
11110
00011
11110
00011
11111
00001
11111
00001
11111
00001
11111
28
*/





