#include<iostream>
#include<vector>
using namespace std;

const int MAXN=1e6, MOD=1e9+7;

int p[MAXN], q[MAXN];
bool v[MAXN], usd[MAXN];
vector<int> comp;

long long GetAns(int idx, int k)
{
    if(k>comp.size()-idx)
    {
        return 0;
    }

    if(idx==comp.size())
    {
        return 1;
    }

    return max(comp[idx]*k*GetAns(idx+1, k-1), GetAns(idx+1, k));
}

bool Fill(int n)
{
    for(int i=0; i<n; i++)
    {
        usd[i]=false, p[i]=-1, v[i]=false;
    }

    for(int i=0; i<n; i++)
    {
        if(v[q[i]] && (i==1 || q[i]!=q[i-2]))
        {
            return false;
        }

        v[q[i]]=true;
    }


    p[1]=q[0];
    usd[p[1]]=true;

    for(int i=1; i<n; i++)
    {
        if(p[i-1]!=-1)
        {
            if(q[i]==p[i-1])
            {
                continue;
            }
            else if(usd[q[i]])
            {
                return false;
            }
            else
            {
                p[i+1]=q[i];
                usd[q[i]]=true;
            }
        }
        else
        {
            if(usd[q[i]])
            {
                return false;
            }
            if(i==n-1)
            {
                p[i-1]=q[i];
                usd[q[i]]=true;
            }
            else if(i==n-2 || q[i+2]!=q[i])
            {
                continue;
            }
            else
            {
                p[i+1]=q[i];
                usd[q[i]]=true;
            }
        }
    }

    for(int i=n-2; i>=0; i--)
    {
        if(p[i+1]!=-1)
        {
            if(q[i]==p[i+1] || (i!=0 && q[i]==p[i-1]))
            {
                continue;
            }
            else if(usd[q[i]])
            {
                return false;
            }
            else
            {
                p[i-1]=q[i];
                usd[q[i]]=true;
            }
        }
        else
        {
            if(usd[q[i]] && !(i!=0 && q[i]==p[i-1]))
            {
                return false;
            }
        }
    }

    return true;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        cin >> q[i];
        q[i]--;
    }

    if(!Fill(n))
    {
        cout << "0\n";
    }
    else
    {
        int s=0;
        for(int i=0; i<n; i+=2)
        {
            if(p[i]==-1)
            {
                s++;
            }
            else if(s!=0)
            {
                comp.push_back(s);
                s=0;
            }
        }

        if(s>0)
        {
            comp.push_back(s);
        }

        s=0;
        for(int i=1; i<n; i+=2)
        {
            if(p[i]==-1)
            {
                s++;
            }
            else if(s!=0)
            {
                comp.push_back(s);
                s=0;
            }
        }

        if(s>0)
        {
            comp.push_back(s);
        }

        int diff=0;
        for(int i=0; i<n; i++)
        {
            if(!v[i])
            {
                diff++;
            }
        }

        cout << GetAns(0, diff)%MOD << "\n";
    }

    return 0;
}
