#include<iostream>
#include<deque>
#include<vector>
using namespace std;

int GetAns(deque<pair<int, int> > d)
{
    int n=5;

    vector<int> v;
    while(!d.empty())
    {
        v.push_back(d.front().second);
        d.front().first--;

        if(d.front().first==0)
        {
            d.pop_front();
        }

        if(!d.empty())
        {
            v.push_back(d.back().second);
            d.back().first--;

            if(d.back().first==0)
            {
                d.pop_back();
            }
        }
    }

    int ans=0, m=v.size();
    for(int i=1; i<m; i++)
    {
        ans+=max(0, v[i]+v[i-1]-n);
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n=5;

    deque<pair<int, int> > d1, d2;
    for(int i=1; i<=n; i++)
    {
        int x;
        cin >> x;

        d1.push_front({x, i});
        d2.push_back({x, i});
    }

    cout << min(GetAns(d1), GetAns(d2)) << "\n";

    return 0;
}
