#include <iostream>
#include <vector>
#include <set>
#include <limits.h>
using namespace std;
int n;
const int MAXN=1000010;
int a[MAXN];
long long mod=1000000007;
int index[MAXN];
int newSeq[MAXN];
bool used[MAXN];
int pairs[MAXN];

long long solve()
{
	fill(index,index+(MAXN-5),-1);
	fill(newSeq,newSeq+(MAXN-5),-1);
	for(int i=1;i<=n;i++)	
	{
		if(index[a[i]]!=-1)
		{
			if(i==index[a[i]]+2)
			{
				newSeq[i-1]=a[i];
				used[i]=true;
				used[i-2]=true;
			}
			else return 0;
		}
		else index[a[i]]=i;
	}
	newSeq[2]=a[1];
	used[1]=true;
	
	newSeq[n-1]=a[n];
	used[n]=true;
	
	for(int i=2;i<n;i++)
	{
		if(newSeq[i-1]!=-1)
		{
			if(newSeq[i-1]!=a[i])
			{
				if(newSeq[i+1]!=-1)
					if(newSeq[i+1]!=a[i])return 0;
					else continue;
				else {newSeq[i+1]=a[i];used[i]=true;}
			}
			else continue;
		}
	}
	
	for(int i=n-1;i>=2;i--)
	{
		if(newSeq[i+1]!=-1)
		{
			if(newSeq[i+1]!=a[i])
			{
				if(newSeq[i-1]!=-1)
					if(newSeq[i-1]!=a[i])return 0;
					else continue;
				else {newSeq[i-1]=a[i];used[i]=true;}
			}
			else continue;
		}
	}
	
//	for(int i=1;i<=n;i++)
//	cout<<newSeq[i]<<" ";
//	cout<<endl;
	if(newSeq[1]==-1)
		pairs[1]=1;
	if(newSeq[n]==-1)
	pairs[n]=1;
	for(int i=2;i<n;i++)
	{
		if(newSeq[i]==-1)
		{
			if(!used[i-1])pairs[i]++;
			if(!used[i+1])pairs[i]++;
		}
	}
	long long mult=1;
	int count=0;
	bool inseq=false;
	for(int i=1;i<=n;i++)
	{
		if(pairs[i]==0)continue;
		if(pairs[i]==1)
		{
			if(!inseq)
			{
				inseq=true;
				count=1;
			}
			else 
			{
				count++;
				mult*=count;
				mult%=mod;
				inseq=false;
			}
		}
		else count++;
	}
	long long missing=0,perm=1;
	for(int i=1;i<=n;i++)
		if(!index[i]==-1)missing++;
	for(int i=1;i<=missing;i++)
		{perm*=i;perm%=mod;}
	mult*=perm;
	mult%=mod;

	
//	for(int i=1;i<=n;i++)
//	cout<<pairs[i]<<" ";
//	cout<<endl;
//
//	
//	for(int i=1;i<=n;i++)
//	cout<<used[i]<<" ";
//	cout<<endl;


	return mult;
}

void init()
{
	cin>>n;
	for(int i=1;i<=n;i++)
		scanf("%d",&a[i]);
}

int main()
{
 	init();
	cout<<solve()<<endl;;
}
/*
14 
7
1
14
4
10
4
10
2
6
12
5
13
3
8

*/
