#include <iostream>
#include <vector>
#include <set>
#include <limits.h>
using namespace std;

long long dp[3010][3010];
int N,M,A,B,K;
int END,JUMP;
long long mod=1000000007;
long long COEF[3010][3010];
long long solve1()
{
	for(int i=1;i<=K;i++)
		dp[i][0]=1;
	for(int i=0;i<=JUMP;i++)
		dp[1][i]=1;
	for(int turn=2;turn<=K;turn++)
	{
		for(int pos=1;pos<=END;pos++)
		{
			dp[turn][pos]=dp[turn][pos-1]+dp[turn-1][pos];
			if(pos>JUMP)
			{
				long long diff=dp[turn][pos-1]-dp[turn-1][pos-JUMP-1];
				if(diff<0){
				diff+=mod*COEF[turn][pos-1];
				diff%=mod;}
				dp[turn][pos]=diff+dp[turn-1][pos];
			}
			dp[turn][pos]%=mod;
			COEF[turn][pos]=dp[turn][pos]/mod;
		}
	}

	return dp[K][END];
}

int solve(int pos,int turns)
{
	if(turns>K)return 0;
	if(pos>END)return 0;
	if(pos==END&&turns<=K)return 1;
	if(dp[pos][turns]!=-1)return dp[pos][turns];
	long long total=0;
	for(int i=0;i<=JUMP;i++)
		total+=solve(pos+i,turns+1);
	if(total>=mod)total%=mod;
	return dp[pos][turns]=total;
}

long long init()
{
	cin>>N>>M>>A>>B>>K;
	END=N;
	JUMP=A;
	for(int i=0;i<=N+3;i++)
		for(int j=0;j<=K+3;j++)
			dp[i][j]=0;
	long long resx=solve1();
	for(int i=0;i<=M+3;i++)
		for(int j=0;j<=K+3;j++)
			dp[i][j]=0;
	END=M;
	JUMP=B;
	long long resy=solve1();
//	cout<<resx<<endl<<resy<<endl;
	return (resy*resx)%mod;
}

int main()
{
 	cout<<init()<<endl;
 	
}
