#include <iostream>
#include <vector>
#include <set>
#include <limits.h>
#include <cstdio>
#include <queue>

using namespace std;

struct Edge
{
	int from;
	int to;
	int dist;
	int magic;
};

int N,M;
vector<Edge> gr[2010];
int dist[2010];
void init()
{
	cin>>N>>M;
	Edge e;
	for(int i=0;i<M;i++)
	{
		scanf("%d%d%d%d",&e.from,&e.to,&e.dist,&e.magic);
		gr[e.from].push_back(e);
	}
}

int solve()
{
	fill(dist,dist+(N+2),INT_MAX);
	int magic=0;
	pair<int,int> CurrNode;
	priority_queue<pair<int,int>, vector<pair<int,int> >, greater<pair<int,int> > > Q;
	Q.push({0,1});
	while(!Q.empty())
	{
		CurrNode=Q.top();
		Q.pop();
		if(CurrNode.second==N)return CurrNode.first;
		if(dist[CurrNode.second]<CurrNode.first)continue;
		for(int i=0;i<gr[CurrNode.second].size();i++)
			if(CurrNode.first+gr[CurrNode.second][i].dist<dist[gr[CurrNode.second][i].to]){
				dist[gr[CurrNode.second][i].to]=CurrNode.first+gr[CurrNode.second][i].dist;
				Q.push({CurrNode.first+gr[CurrNode.second][i].dist, gr[CurrNode.second][i].to});
			}
	}
}

int main()
{
 	init();
	cout<<solve()<<endl; 	
}
/*
7 8
1 2 1 0
2 4 1 0
4 6 1 0
6 7 3 5
1 3 5 2
3 5 2 3
5 7 3 0
3 4 3 1

*/
