#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 1000000;

int q[MAXN];
vector<int> a[MAXN];
int n;
bool ff[MAXN];
vector<int> b;

void init()
{
	scanf("%d",&n);
	for(int i=0;i<n;i++)
	{
		scanf("%d",&q[i]);
		q[i]--;
	}
}

void genA()
{
	for(int i=0;i<n;i++)
	{
		ff[q[i]]=true;
		if(i-1>=0) a[i-1].push_back(q[i]);
		if(i+1<n) a[i+1].push_back(q[i]);
	}
	
	for(int i=0;i<n;i++)
		if(!ff[i]) b.push_back(i);
	
	a[1].clear();
	a[n-2].clear();
	a[1].push_back(q[0]);
	a[n-2].push_back(q[n-1]);
}

void debug()
{
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<a[i].size();j++)
		{
			cout<<a[i][j]<<" ";
		}
		cout<<endl;
	}
	
	cout<<"B:\n";
	for(int i=0;i<b.size();i++)
		cout<<b[i]<<" ";
	cout<<endl;
}

bool used[MAXN];
int ways(int i)
{
	if(i==n) return 1;
	
	int ans=0;
	for(int j=0;j<a[i].size();j++)
		if(!used[a[i][j]])
		{
			used[a[i][j]]=true;
			ans+=ways(i+1);
			used[a[i][j]]=false;
		}
		
	if(i!=1&&i!=n-2)
		for(int j=0;j<b.size();j++)
		{
			if(!used[b[j]])
			{
				used[b[j]]=true;
				ans+=ways(i+1);
				used[b[j]]=false;
			}
		}
	
	return ans;
}

int main()
{
	init();
	genA();
	cout<<ways(0)<<endl;
}