#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 1000000;
const int mod = 1000000007;

int q[MAXN];
vector<int> a[MAXN];
int n;
int ff[MAXN];
vector<int> b;
vector<int> c;
bool endP=false;

void init()
{
    scanf("%d",&n);
    for(int i=0;i<n;i++)
    {
        scanf("%d",&q[i]);
        q[i]--;
    }
}

void genA()
{
    for(int i=0;i<n;i++)
    {
        ff[q[i]]++;
        
        if(ff[q[i]]==3)
        {
            endP=true;
            return;
        }
        else if(ff[q[i]]==2)
        {
        //cout<<"Q: "<<q[i-2]<<" "<<q[i]<<" "<<q[i+2]<<" i = "<<i<<endl;
            if(q[i-2]!=q[i]&&q[i]!=q[i+2])
            {
                endP=true;
                return;
            }
        }
        
        if(i-1>=0) a[i-1].push_back(q[i]);
        if(i+1<n) a[i+1].push_back(q[i]);
    }
    
    for(int i=0;i<n;i++)
        if(!ff[i]) b.push_back(i);
    
    a[1].clear();
    a[n-2].clear();
    a[1].push_back(q[0]);
    a[n-2].push_back(q[n-1]);
    
    c.push_back(1);
    c.push_back(n-2);
    
    for(int i=2;i<n-3;i++)
    {
        if(q[i-1]==q[i+1])
        {
            a[i].clear();
            a[i].push_back(q[i-1]);
            c.push_back(i);
        }
    }
}

void debug()
{
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<a[i].size();j++)
        {
            cout<<a[i][j]+1<<" ";
        }
        cout<<endl;
    }
    
    cout<<"B:\n";
    for(int i=0;i<b.size();i++)
        cout<<b[i]+1<<" ";
    cout<<endl;
}

int path[MAXN];
bool used[MAXN];
int ways(int i)
{
    if(i==n)
    {
        for(int j=0;j<n;j++)
            cout<<path[j]+1<<" ";
        cout<<endl;
        return 1;
    }
    
    int ans=0;
    for(int j=0;j<a[i].size();j++)
        if(!used[a[i][j]])
        {
            used[a[i][j]]=true;
            path[i]=a[i][j];
            ans+=ways(i+1);
            used[a[i][j]]=false;
        }
        
    for(int j=0;j<c.size();j++)
        if(c[j]==i) return ans%mod;
    
    for(int j=0;j<b.size();j++)
    {
        if(!used[b[j]])
        {
            used[b[j]]=true;
            path[i]=b[j];
            ans+=ways(i+1);
            used[b[j]]=false;
        }
    }
    
    return ans%mod;
}

int main()
{
    init();
    genA();
    if(b.size()==0) endP=true;
    if(endP)
    {
        cout<<"0\n";
        return 0;
    }
    //debug();
    cout<<ways(0)<<endl;
}