#include <iostream>

using namespace std;

const int MAXN=300;
const int mod = 1000000007;

int n,m,a,b,k;
int dp[MAXN][MAXN][MAXN];

int ways(int i,int j,int s)
{
	if(s==k)
	{
		if(i==n&&j==m) return 1;
		return 0;
	}
	
	if(dp[i][j][s]!=-1) return dp[i][j][s];
	
	int ret = 0;
	for(int x=0;x<=a;x++)
	{
		for(int y=0;y<=b;y++)
		{
			ret+=ways(i+x,j+y,s+1);
		}
	}
	
	return dp[i][j][s]=ret%mod;
}

int main()
{
	cin>>n>>m>>a>>b>>k;
	
	for(int i=0;i<MAXN;i++)
	{
		for(int j=0;j<MAXN;j++)
		{
			for(int ii=0;ii<MAXN;ii++)
			{
				dp[i][j][ii]=-1;
			}
		}
	}
	
	cout<<ways(0,0,0)<<endl;
	
}