#include <iostream>

using namespace std;

typedef long long ll;

const ll MAXN = 301;
const ll mod = 1000000007;

ll n,m,a,b,k;
ll dp[MAXN][MAXN][MAXN];

ll ways(ll i,ll j,ll s)
{
	if(s==k)
	{
		if(i==n&&j==m) return 1;
		return 0;
	}
	
	if(dp[i][j][s]!=-1) return dp[i][j][s];
	
	ll ret = 0;
	for(ll x=0;x<=a;x++)
	{
		if(x+i>n) break;
		for(ll y=0;y<=b;y++)
		{
			if(y+j>m) break;
			ret+=ways(i+x,j+y,s+1)%mod;
		}
	}
	
	dp[i][j][s]=ret%mod;
	return ret%mod;
}

int main()
{
	cin>>n>>m>>a>>b>>k;
	
	for(int i=0;i<=n;i++)
	{
		for(int j=0;j<=m;j++)
		{
			for(int ii=0;ii<=k;ii++)
			{
				dp[i][j][ii]=-1;
			}
		}
	}
	
	cout<<ways(0,0,0)<<endl;
}