#include <iostream>

using namespace std;

typedef long long ll;

const ll MAXN = 301;
const ll mod = 1000000007;

ll n,m,a,b,k;
ll dp[MAXN][MAXN][MAXN];

void toPref(ll idx)
{
	for(ll i=1;i<=n;i++)
	{
		dp[i][0][idx]=(ll)(dp[i][0][idx]+dp[i-1][0][idx])%mod;
	}
	
	ll r;
	for(ll j=1;j<=m;j++)
	{
		r=0;
		for(ll i=0;i<=n;i++)
		{
			r=(ll)(r+dp[i][j][idx])%mod;
			dp[i][j][idx]=(ll)(r+dp[i][j-1][idx])%mod;
		}
	}
}

ll query(ll x0,ll y0,ll x1,ll y1,ll idx)
{
	ll ret=dp[x1][y1][idx];
	if(x0) ret-=dp[x0-1][y1][idx];
	if(y0) ret-=dp[x1][y0-1][idx];
	if(x0&&y0) ret+=dp[x0-1][y0-1][idx];
	
	return ret%mod;
}

int main()
{	
	cin>>n>>m>>a>>b>>k;
	
	dp[0][0][0]=1;
	
	for(ll i=1;i<=k;i++)
	{
		toPref(i-1);
		for(ll j=0;j<=n;j++)
		{
			for(ll ii=0;ii<=m;ii++)
			{
				dp[j][ii][i]=query(max((ll)0,j-a),max((ll)0,ii-b),j,ii,i-1);
				//cout<<dp[j][ii][i]<<" ";
			}
			//cout<<endl;
		}
		//cout<<endl;
	}
	
	cout<<dp[n][m][k]<<endl;
}