#include <iostream>
using namespace std;

int n, m, a, b, k;
const int MAXNMABK = 10000;

const long long int MOD = 1e9 + 7;

long long int dp[MAXNMABK + 1][MAXNMABK + 1];

long long int solve(int sum, int max_add) {
	for(int i = 0; i <= k; ++i) {
		for(int j = 0; j <= sum; ++j) {
			dp[i][j] = 0;
		}
	}
	dp[0][0] = 1;

	for(int i = 0; i < k; ++i) {
		for(int j = 0; j <= sum; ++j) {
			if(j <= max_add) {
				if(j == 0) {
					dp[i + 1][j] = 1;
				}
				else {
					dp[i + 1][j] = (dp[i + 1][j - 1] + dp[i][j]);
				}
			}
			else {
				dp[i + 1][j] = (dp[i + 1][j - 1] - dp[i][j - (max_add + 1)] + dp[i][j]);
			}
		}

		/*for(int j = 0; j <= sum; ++j) {
			cout << dp[i][j] << " ";
		}

		cout << endl;*/
	}

	/*for(int j = 0; j <= sum; ++j) {
		cout << dp[k][j] << " ";
	}

	cout << endl;*/

	return dp[k][sum] % MOD;
}

int main() {
	cin >> n >> m >> a >> b >> k;
	long long int solve1 = solve(n, a);
	long long int solve2 = solve(m, b);
	//cout << solve1 << " " << solve2 << endl;
	cout << (solve1 * solve2) % MOD << endl;

	/*k = 46;
	cout << solve(11, 1) << endl;*/
}

/*
3 1 2 3 2
*/

/*
100 100 30 30 10
*/