#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 5
using namespace std;
int n = 0;
int cnt[MAXN + 1];
int record = 0;

void input()
{
    for (int i = 1; i <= 5; ++i)
    {
        cin >> cnt[i];
        n += cnt[i];
    }
}

int conflict(int x, int y)
{
    return max(0, x + y - MAXN);
}

void solve()
{
    int top = 0, bot = 0;
    int value[2];

    for (int i = MAXN; i >= 1; --i)
        if (cnt[i])
        {
            value[1] = i;
            break;
        }

    for (int i = 1; i <= MAXN; ++i)
        if (cnt[i])
        {
            value[0] = i;
            break;
        }

    vector <int> top_v, bot_v;
    bool idx = 1;

    while (n && value[0] <= value[1])
    {
        record += conflict(top, value[idx]);
        top_v.push_back(value[idx]);
        top = value[idx];
        --cnt[value[idx]];
        --n;

//        cout << "top: " << top << endl;

        while (!cnt[value[idx]])
        {
            if (idx)
                --value[idx];
            else
                ++value[idx];
        }

        if (!n)
            break;

        record += conflict(bot, value[idx]);
        bot_v.push_back(value[idx]);
        bot = value[idx];
        --cnt[value[idx]];
        --n;

//        cout << "bot: " << bot << endl;

        while (!cnt[value[idx]])
        {
            if (idx)
                --value[idx];
            else
                ++value[idx];
        }

        idx ^= 1;
    }

    record += conflict(top, bot);

//    int sz = top_v.size();
//    for (int i = 0; i < sz; ++i)
//        cout << top_v[i] << " ";
//
//    sz = bot_v.size();
//    for (int i = sz - 1; i >= 0; --i)
//        cout << bot_v[i] << " ";
//    cout << endl;

    cout << record << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
