#include<iostream>
#include<vector>
#include<queue>
using namespace std;

const int MAXV = 200000000;
struct States
{
    int id;
    int p;
    bool vis;
};
States v[101];
bool operator <(States a, States b) {return a.p > b.p;}
priority_queue<States> q;

struct Path
{
    vector<int> n;
    vector<int> val;
};
Path p[101];

int n,m;
void Read()
{
    cin>>n>>m;
    int a,b,c,d;
    for(int i=0;i<m;i++)
    {
        cin>>a>>b>>c>>d;
        p[a].n.push_back(b);
        p[a].val.push_back(c);
    }
    for(int i=1;i<=n;i++)
    {
        v[i].id = i;
        v[i].p = MAXV;
        v[i].vis = false;
    }
    v[1].p=0;
}

void print()
{
      for(int i=1;i<=n;i++)
    {
        cout<<v[i].id<<" "<<v[i].p<<" "<<v[i].vis<<endl;
    }
    cout<<endl;
}

void Solve()
{
    q.push(v[1]);v[1].vis = true;
    States c;
    while(q.empty()!=1)
    {
        c=q.top();
        //cout<<c.id<<endl;
        q.pop();
        for(int i=0;i<p[c.id].n.size();i++)
        {
            //cout<<p[c.id].n[i];
            //cout<<" "<<v[p[c.id].n[i]].vis<<endl;
            //cout<<" "<<c.p + p[c.id].val[i]<<endl;
            v[p[c.id].n[i]].p = min(v[p[c.id].n[i]].p, v[c.id].p + p[c.id].val[i]);
            if(v[p[c.id].n[i]].vis == false) {
                    q.push(v[p[c.id].n[i]]);
                    v[p[c.id].n[i]].vis = true;
            }

        }//print();
    }
    if(v[n].vis == false) cout<<"-1"<<endl;
    else cout<<v[n].p<<endl;

}


int main()
{
    Read();
    Solve();
    return 0;
}
/*
7 8
1 2 1 0
2 4 1 0
2 6 1 0
6 7 3 5
1 3 5 2
3 5 2 3
5 7 3 0
3 4 3 1
*/
/*
7 16
1 1 2 0
3 2 1 0
1 3 2 0
6 7 5 0
4 6 2 0
4 7 10 0
4 5 1 0
1 2 1 0
5 7 9 0
6 6 2 0
2 4 3 0
3 4 3 0
3 5 1 0
5 6 2 0
3 6 2 0
3 6 1 0


*/
