#include<bits/stdc++.h>
using namespace std;
const long long add1 = 1e10;
const long long add2 = 1e4;
const long long max_magic = 9999990000;
const int MAX_N = 2002;
long long make_hash(long long _dist, long long _magic, long long _v)
{
    return _dist*add1+(max_magic-_magic*add2)+_v;
}
priority_queue<long long, vector<long long>, greater<long long> > pq;
vector< pair< pair<long long,long long>, long long > > adj[MAX_N];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,m;
    cin>>n>>m;
    int u0,v0,w0,d0;
    for(int i=1; i<=m; i++)
    {
        cin>>u0>>v0>>w0>>d0;
        adj[u0].push_back({{d0,w0},v0}); /// d,m,v
    }
    pq.push(make_hash(0,0,1));
    while(!pq.empty())
    {
        long long hash1 = pq.top();
//        cout<<hash1<<endl;
        pq.pop();
        long long  dist = hash1/add1;
        long long magic = max_magic-((hash1%add1)/add2);
        long long v = hash1%add2;
        if(v == n)
        {
            cout<<dist<<endl;
            return 0;
        }
        for(auto x: adj[v])
        {
            pq.push(make_hash(x.first.first+dist,max_magic-(x.first.second+magic),x.second));
        }
    }
    cout<<-1<<endl;
    return 0;
}
