#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long add1 = 1e10;
const long long add2 = 1e4;
const long long max_magic = 999999;
const long long INF = 1e9+7;
const int MAX_N = 102;
long long make_hash(long long _dist, long long _magic, long long _v)
{
    return _dist*add1+((max_magic-_magic)*add2)+_v;
}
priority_queue<long long, vector<long long>, greater<long long> > pq;
vector< pair< pair<long long,long long>, long long > > adj[MAX_N];
pair< pair<long long,long long>, long long > best[MAX_N];
unordered_map<long long,long long> used;
int brv[MAX_N];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,m;
    cin>>n>>m;
    int u0,v0,w0,d0;
    for(int i=1; i<=m; i++)
    {
        cin>>u0>>v0>>w0>>d0;
        adj[u0].push_back({{w0,d0},v0}); /// d,m,v
    }
    for(int i=1; i<=n; i++)
    {
        best[i].first.first = INF;
        best[i].first.second = INF;
    }
    long long res = -1;
    pq.push(make_hash(0,0,1));
    while(!pq.empty())
    {
        long long hash1 = pq.top();
        pq.pop();
        long long dist = hash1/add1;
        long long magic = max_magic-((hash1%add1)/add2);
        long long v = hash1%add2;
        if(brv[v] > 3000) continue;
        best[v].first.first = min(dist,best[v].first.first);
        best[v].first.second = min(magic,best[v].first.second);
        brv[v]++;
        if(v == n)
        {
            if(res == -1) res = dist;
            else res = min(res,dist);
            if(clock()/CLOCKS_PER_SEC == 16000)
            {
                cout<<0<<endl;
                return 0;
            }
        }
        for(auto x: adj[v])
        {
//            cout<<x.first.first<<endl;
//            cout<<dist+max(0LL,(x.first.first-magic))<<" "<<(x.first.second+max(0LL,magic-x.first.first))<<" "<<x.second<<endl;
//            cout<<make_hash(dist+max(0LL,(x.first.first-magic)),(x.first.second+max(0LL,magic-x.first.first)),x.second)<<endl;
            if((best[v].first.first <= dist+max(0LL,(x.first.first-magic)) && best[v].first.second >= (x.first.second+max(0LL,magic-x.first.first)))) continue;
            if(brv[v] <= 3000) pq.push(make_hash(dist+max(0LL,(x.first.first-magic)),(x.first.second+max(0LL,magic-x.first.first)),x.second));
        }
    }
    if(res == -1)
    cout<<-1<<endl;
    else cout<<res<<endl;
    return 0;
}

