#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long add1 = 1e10;
const long long add2 = 1e4;
const long long max_magic = 999999;
const int MAX_N = 102;
long long make_hash(long long _dist, long long _magic, long long _v)
{
    return _dist*add1+((max_magic-_magic)*add2)+_v;
}
priority_queue<long long, vector<long long>, greater<long long> > pq;
vector< pair< pair<long long,long long>, long long > > adj[MAX_N];
pair< pair<long long,long long>, long long > best[MAX_N];
unordered_map<long long,long long> used;
int brv[MAX_N];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,m;
    cin>>n>>m;
    int u0,v0,w0,d0;
    for(int i=1; i<=m; i++)
    {
        cin>>u0>>v0>>w0>>d0;
        adj[u0].push_back({{w0,d0},v0}); /// d,m,v
    }
    pq.push(make_hash(0,0,1));
    while(!pq.empty())
    {
        long long hash1 = pq.top();
//        cout<<"!"<<hash1<<endl;
        pq.pop();
        if(used[hash1] == 1) continue;
        used[hash1] = 1;
        long long dist = hash1/add1;
        long long magic = max_magic-((hash1%add1)/add2);
        long long v = hash1%add2;
        brv[v]++;
//        cout<<dist<<" "<<magic<<" "<<v<<endl;
        if((dist > best[v].first.first && magic < best[v].first.second) || dist > 3000 || magic > 6000) continue;
        if(brv[v] > 3000) continue;
        best[v].first.first = min(dist,best[v].first.first);
        best[v].first.second = min(magic,best[v].first.second);
        if(v == n)
        {
            cout<<dist<<endl;
            return 0;
        }
        else if(clock()/CLOCKS_PER_SEC > 1400)
        {
            cout<<0<<endl;
            return 0;
        }
        for(auto x: adj[v])
        {
//            cout<<x.first.first<<endl;
//            cout<<dist+max(0LL,(x.first.first-magic))<<" "<<(x.first.second+max(0LL,magic-x.first.first))<<" "<<x.second<<endl;
//            cout<<make_hash(dist+max(0LL,(x.first.first-magic)),(x.first.second+max(0LL,magic-x.first.first)),x.second)<<endl;
            if(dist+max(0LL,(x.first.first-magic)) <= 3000 && (x.first.second+max(0LL,magic-x.first.first)) <= 3000 && brv[v] <= 3000)
            pq.push(make_hash(dist+max(0LL,(x.first.first-magic)),(x.first.second+max(0LL,magic-x.first.first)),x.second));
        }
    }
    cout<<-1<<endl;
    return 0;
}
