#include<bits/stdc++.h>
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
#define ll long long
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const ll MOD = 1e9 + 7;
const ll MAXN = 1e6 + 6;

ll n, fact[MAXN];
vector<int> Q, P, used;
matrix<int> freq;

void init(){
	fact[1] = 1;
	for(ll i = 2; i < MAXN; i ++) fact[i] = (i * fact[i - 1]) % MOD;
}

int main(){
	init();
	int n; cin >> n;
	Q = used = P = vector<int>(n + 5);
	for(auto &x : Q) cin >> x;
	freq = matrix<int>(n + 1);
	/// freq broika == 1 ili broika == 2 ii prez edno
	for(int i = 0; i < n; i ++){
		freq[Q[i]].pb(i);
	}
	for(int i = 1; i <= n; i ++){
		if(freq[i].size() > 2){ cout << "0\n"; return 0; }
		if(freq[i].size() == 2 && abs(freq[i][0] - freq[i][1]) != 2){ cout << "0\n"; return 0; }
	}
	// case1
	if(n == 3 && Q[0] != Q[n - 1]){ cout << "0\n"; return 0; }
	/// left right
	P[1] = Q[0]; P[n - 2] = Q[n - 1];
	for(int i = 2; i < n; i += 2){
		if(Q[i] != P[i - 1] && i + 1 < n){
			P[i + 1] = Q[i];
		}
		if(Q[i] == P[i - 1]) break;
	}
	/// right left
	if(P[n - 2] != Q[n - 1] && P[n - 2] != 0){ cout << "0\n"; return 0; }
	for(int i = n - 3; i >= 0; i -= 2){
		if(Q[i] != P[i + 1] && i - 1 >= 0){
			if(P[i - 1] == 0){
				P[i - 1] = Q[i];
			}
			else if(P[i - 1] != Q[i]){ cout << "0\n"; return 0; }
			else{
				break;
			}
		}
		if(Q[i] == P[i + 1]){
			break;
		}
	}
	// put i - 1 & i + 1
	for(int i = 1; i < n - 1; i ++){
		if(Q[i - 1] == Q[i + 1]){
			if(P[i] == 0){
				P[i] = Q[i - 1];
			}
			else if(P[i] != Q[i - 1]){ cout << "0\n"; return 0; }
		}
	}
	/// conflicts
	for(int i = 1; i < n - 1; i ++){
		if((P[i - 1] != Q[i] && P[i - 1] != 0) && (P[i + 1] != Q[i] && P[i + 1] != 0)){ cout << "0\n"; return 0; }
	}
	/// all done?
	if(count(all(P), 0) == 0){ return 1; }
	ll ans = 1, cnt = 0;
	for(int i = 0; i < n; i ++){
		if(P[i] == 0){
			ll sz = 0;
			for(int idx = i; idx < n; idx += 2){
				if(P[idx]) break;
				P[idx] = -1;
				++ sz;
			}
			ans = (ans * sz) % MOD;
			++ cnt;
		}
	}
	cout << (ans * fact[cnt]) % MOD << endl;
}
/**

*/