#include<bits/stdc++.h>
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
#define ll long long
#define fr first
#define sc second
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int n, m;
matrix<pair<int, int>> G;

int main(){
	cin >> n >> m;
	G = matrix<pair<int, int>>(n + 1);
	for(int i = 0; i < m; i ++){
		int u, v, c, d; cin >> u >> v >> c >> d;
		assert(d == 0);
		G[u].pb({v, c});
		G[v].pb({u, c});
	}
	priority_queue<pair<int, int>, vector<pair<int, int>>, less<pair<int, int>>> pq;
	vector<int> dist(n + 1, 1e9), used(n + 1, false);
	dist[1] = 0; 
	pq.push({1, 0});
	while(!pq.empty()){
		auto u = pq.top().fr;
		pq.pop();
		if(!used[u]){
			used[u] = true;
			for(auto [v, w] : G[u]){
				if(!used[v] && dist[u] + w < dist[v]){
					dist[v] = dist[u] + w;
					pq.push({v, dist[v]});
				}
			}
		}
	}
	cout << dist[n] << endl;
}
/**

*/