#include<bits/stdc++.h>
using namespace std;

const int nmax=2e3+42;

int n,m;
vector< pair< int/*to*/,pair<int/*dist*/,int/*magic*/> > > adj[nmax];

long long magic_was[nmax];

priority_queue< pair<int/*dist*/, pair<int/*magic*/,int/*where*/> > > pq;

bool been[nmax];

void dfs(int node)
{
    if(been[node])return;

    been[node]=1;

    for(auto w:adj[node])
        dfs(w.first);
}

int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=n;i++)magic_was[i]=-1;

    for(int i=1;i<=m;i++)
    {
        int a,b,c,d;

        scanf("%i%i%i%i",&a,&b,&c,&d);

        adj[a].push_back({b,{c,d}});
    }

    dfs(1);

    if(been[n]==0)
    {
        printf("-1\n");
        return 0;
    }

    pq.push({0,{0,1}});

    while(pq.size())
    {
        pair<int/*dist*/, pair<int/*magic*/,int/*where*/> > tp=pq.top();

        pq.pop();

        int dist=-tp.first;
        int magic=tp.second.first;
        int node=tp.second.second;

        if(magic_was[node]>=magic)continue;

        if(node==n)
        {
            printf("%i\n",dist);
            exit(0);
        }

        magic_was[node]=magic;

        for(auto w:adj[node])
        {
            for(int save=min(w.second.first,magic);save>=0;save--)
            {
                int dist_now=dist+w.second.first-save;

                int magic_now=magic-save+w.second.second;

                int node_now=w.first;

                pq.push({-dist_now,{magic_now,node_now}});
            }
        }
    }

    return 0;
}
