#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 2003; 
const int maxmagic = 2000 * 30 + 3; 
const unsigned short inf = 60003; 

typedef unsigned short us;

struct road {
    us to, dist, magic;
    road(us to, us dist, us magic) {
        this->to = to;
        this->dist = dist;
        this->magic = magic;
    }
};

us n, m; 
vector <road> adj[maxn];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        us a, b, c, d;
        cin >> a >> b >> c >> d;
        
        adj[a].push_back(road(b, c, d));
    }
}

us cost[maxn][maxmagic];
vector <pair <us, us> > pq[maxmagic];
void dijkstra() {
    for (int i = 1; i <= n; i++)
    for (int j = 0; j <= n * 30; j++)
    cost[i][j] = inf;
    
    pq[0].push_back({1, 0});
    cost[1][0] = 0;
    for (int i = 0; i <= n * 30; ) {
        if (pq[i].empty()) {
            i++;
            continue;
        }
        
        auto node = pq[i].back();
        pq[i].pop_back();
        
        if (node.first == n)
        return;
        
        if (i != cost[node.first][node.second])
        continue;
        
        for (auto e: adj[node.first]) {
            if (node.second >= e.dist) {
                if (cost[e.to][node.second - e.dist + e.magic] > i) {
                    cost[e.to][node.second - e.dist + e.magic] = i;
                    pq[i].push_back({e.to, node.second - e.dist + e.magic});
                }
            }
            
            else {
                if (cost[e.to][e.magic] > i + e.dist - node.second) {
                    cost[e.to][e.magic] = i + e.dist - node.second;
                    pq[i + e.dist - node.second].push_back({e.to, e.magic});
                }
            }
        }		
    }
}

void solve()
{
    dijkstra();
    us ans = inf;
    for (int i = 0; i <= n * 30; i++)
    ans = min(ans, cost[n][i]);
    
    if (ans == inf)
    cout << -1 << endl;
    
    else 
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    read();
    solve();
}
