#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#define endl '\n'

using namespace std;

const int maxn = 2003; 
const int maxmagic = 2000 * 30 + 3; 
const unsigned short inf = 60003; 

typedef unsigned short us;

struct road {
    us to, dist, magic;
    road(us to, us dist, us magic) {
        this->to = to;
        this->dist = dist;
        this->magic = magic;
    }
};

us n, m; 
vector <road> adj[maxn];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        us a, b, c, d;
        cin >> a >> b >> c >> d;
        
        adj[a].push_back(road(b, c, d));
    }
}

us max_magic[maxmagic][maxn];
vector <pair <us, us> > curr;
int dijkstra() {
    for (int i = 0; i <= n * 30; i++)
    for (int j = 1; j <= n; j++)
    max_magic[i][j] = inf;
    
    max_magic[0][1] = 0;
    curr.push_back({1, 0});
    for (int i = 0; i <= n * 30; ) {
        if (curr.empty()) {
            i++;
            for (int j = 1; j <= n; j++)
            if (max_magic[i][j] != inf)
            curr.push_back({j, max_magic[i][j]});
            
            continue;
        }
        
        pair <us, us> node = curr.back();
        curr.pop_back();
        
        if (node.first == n)
        return i;
        
        if (node.second != max_magic[i][node.first])
        continue;
        
        for (auto e: adj[node.first]) {
            if (node.second >= e.dist) {
                if (max_magic[i][e.to] == inf || max_magic[i][e.to] < node.second - e.dist + e.magic) {
                   max_magic[i][e.to] = node.second - e.dist + e.magic;
                   curr.push_back({e.to, max_magic[i][e.to]});
                }
            }
            
            else 
            if (max_magic[i + e.dist - node.second][e.to] == inf || max_magic[i + e.dist - node.second][e.to] < e.magic)
            max_magic[i + e.dist - node.second][e.to] = e.magic;
        }		
    }
    
    return -1;
}

void solve()
{
    cout << dijkstra() << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    read();
    solve();
}
