#include<iostream>
#define MOD 1000000007
using namespace std;
//k - numbers left, s - sum left, a - max number
long long memo[3002][3002];
long long ways(long long k, long long s, long long a){
    //cout<<"state: "<<k<<" "<<s<<" "<<a<<endl;
    if(s<0 || k*a<s){
        return 0;
    }
    if(s==0 || k*a==s){
        return 1;
    }
    if(k==0){
        return 0;
    }
    //cout<<k<<" "<<s<<endl;
    if(memo[k][s]!=-1){
        return memo[k][s];
    }
    long long ans=0;
    for(long long i=0;i<=a;i++){
        ans+=ways(k-1, s-i, a);
        ans%=MOD;
    }
    memo[k][s]=ans;
    return ans;
}
int main(){
    long long n,m,a,b,k;
    cin>>n>>m>>a>>b>>k;
    for(int i=0;i<=3000;i++){
        for(int j=0;j<=3000;j++){
            memo[i][j]=-1;
        }
    }
    long long t1=ways(k,n,a);
    for(int i=0;i<=3000;i++){
        for(int j=0;j<=3000;j++){
            memo[i][j]=-1;
        }
    }
    long long t2=ways(k,m,b);
    cout<<(t1*t2)%MOD<<endl;
    return 0;
}
