#include<iostream>
#include<vector>
#include<queue>
using namespace std;
struct edge
{
    int b,c,d;
    bool operator < (edge e)const
    {
        if(this->c!=e.c)
        {
            return this->c>e.c;
        }
        else
        {
            return this->d<e.d;
        }
    }
};
bool access[2005][2005];
int visited[100000];
int vismag[100000];
int visval[100000];
vector<edge> susedi[100000];
priority_queue<edge> paths;

//v - current vertex, a - original vertex
void dfs(int v, int a){
    if(access[a][v])return;
    access[a][v]=1;
    for(int i=0;i<susedi[v].size();i++){
        dfs(susedi[v][i].b,a);
    }
}
int main()
{
    int n,m;
    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        int a,b,c,d;
        cin>>a>>b>>c>>d;
        susedi[a].push_back({b,c,d});
    }
    for(int i=1;i<=n;i++){
        dfs(i, i);
    }
    paths.push({1,0,0});
    while(!paths.empty())
    {
        edge curr=paths.top();
        paths.pop();
        if(!access[curr.b][n]){
            continue;
        }

        if(visited[curr.b]>200)
        {
            continue;
        }
        visited[curr.b]++;
        if(curr.c==visval[curr.b] && visval[curr.b]!=0 && curr.d>vismag[curr.b]){
            cout<<curr.c<<endl;
            //cout<<0/0;
            return 0;
        }
        visval[curr.b]=curr.c;
        vismag[curr.b]=curr.d;
        if(curr.b==n)
        {
            cout<<curr.c<<endl;
            return 0;
        }
        for(int i=0; i<susedi[curr.b].size(); i++)
        {
            if(visited[susedi[curr.b][i].b]<200)
            {
                int d_cost=min(curr.d,susedi[curr.b][i].c);
                paths.push({susedi[curr.b][i].b,curr.c+susedi[curr.b][i].c-d_cost,curr.d+susedi[curr.b][i].d-d_cost});
            }
        }
    }
    cout<<-1<<endl;
    return 0;
}
