#include<iostream>
#include<vector>
#include<queue>
#include<set>
using namespace std;
struct edge
{
    long long b,c,d;
    bool operator < (edge e)const
    {
        if(this->c!=e.c)
        {
            return this->c>e.c;
        }
        else
        {
            return this->d<e.d;
        }
    }
};
bool access[2005][2005];
long long visited[100000];
long long vismag[100000];
long long visval[100000];
vector<edge> susedi[100000];
priority_queue<edge> paths;
int minReq[10000];
//v - current vertex, a - original vertex, c - current len, d = current magic
void dfs(long long v, long long a, long long c, long long d, long long req){
    if(v==a && c<d){
        if(minReq[v]==-1 || req<minReq[v]){
            minReq[v]=req;
        }
    }
    if(access[a][v])return;
    access[a][v]=1;
    for(long long i=0;i<susedi[v].size();i++){
        dfs(susedi[v][i].b,a,c+susedi[v][i].c,d+susedi[v][i].d,max(req, (c+susedi[v][i].c)-d));
    }
}
int main()
{
    long long n,m;
    cin>>n>>m;
    for(long long i=0; i<m; i++)
    {
        long long a,b,c,d;
        cin>>a>>b>>c>>d;
        susedi[a].push_back({b,c,d});
    }
    for(long long i=1;i<=n;i++){
        minReq[i]=-1;
        dfs(i, i, 0, 0,0);
    }
    /*cout<<"access: "<<endl;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=n;j++){
            cout<<access[i][j]<<" ";
        }
        cout<<endl;
    }*/
    paths.push({1,0,0});
    while(!paths.empty())
    {
        edge curr=paths.top();
        paths.pop();
        if(!access[curr.b][n]){
                //cout<<curr.b<<endl;
            continue;
        }

        if(visited[curr.b]>2000)
        {
            continue;
        }
        visited[curr.b]++;
        if(minReq[curr.b]!=-1 && curr.d>=minReq[curr.b]){
            cout<<curr.c<<endl;
            //cout<<0/0;
            return 0;
        }
        visval[curr.b]=curr.c;
        vismag[curr.b]=curr.d;
        //curr.path.insert(curr.b);
        if(curr.b==n)
        {
            cout<<curr.c<<endl;
            return 0;
        }
        for(long long i=0; i<susedi[curr.b].size(); i++)
        {
            long long d_cost=min(curr.d,susedi[curr.b][i].c);
            //path2.insert(susedi[curr.b][i].b);
            paths.push({susedi[curr.b][i].b,curr.c+susedi[curr.b][i].c-d_cost,curr.d+susedi[curr.b][i].d-d_cost});
        }
    }
    cout<<-1<<endl;
    return 0;
}
