#include<iostream>

using namespace std;

int main(){

    ios_base::sync_with_stdio(false);   /// some magic ;)
    cin.tie(NULL);                      /// and some more XD

    int b[6];   /// we will use b[1] = b1, ..., b[5] = b5
    int n = 0;  /// n = sum of all bi

    for(int i = 1; i <= 5; i++){
        cin >> b[i];
        n += b[i];
    }

    int lastInSequence[2];
    long long record = 0;

    for(int i = 1; i<=n ; i++){
        if( ((i+1)/2) % 2 == 1){   /// i.e. i = 1,2,5,6,9,10,...
            for(int j = 5; j >= 1; j--){
                if(b[j]>0){
                    b[j]--;
                    if(i != 1 && i != 2 && lastInSequence[i%2] + j > 5) record += lastInSequence[i%2] + j - 5; ///formula for number of conflicts
                    lastInSequence[i%2] = j;
                    break;
                }
            }
        }
        else{ /// i.e. i = 3,4,7,8,11,12,...
            for(int j = 1; j <= 5; j++){
                if(b[j]>0){
                    b[j]--;
                    if(lastInSequence[i%2] + j > 5)record += lastInSequence[i%2] + j - 5;
                    lastInSequence[i%2] = j;
                    break;
                }
            }
        }
    }

    int conflictInMiddle = lastInSequence[0] + lastInSequence[1] - 5;
    if(conflictInMiddle > 0) record += conflictInMiddle;

    cout << record << endl;

    return 0;
}
