#pragma GCC optimize ("O3")
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n, ans;
vector<int> def, tg;

bool valid() {
    for (int i = 0; i < n; i++) {
        if (i == 0 && tg[i] != def[i + 1]) return false;
        if (i == n - 1 && tg[i] != def[n - 2]) return false;
        if (tg[i] != def[i - 1] && tg[i] != def[i + 1]) return false;
    }
    return true;
}

void bruteForce() {
    do {
        if (valid()) ans++;
    } while (next_permutation(def.begin(), def.end()));
}

void input() {
    cin >> n;
    for (int i = 0, x; i < n; i++) {
        cin >> x;
        tg.push_back(x);
    }
    for (int i = 1; i <= n; i++) {
        def.push_back(i);
    }
}

void solve() {
    bruteForce();
}

void output() {
    cout << ans << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    input();
    solve();
    output();

    return 0;
}
