#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 1e6 + 10;
vector<int> where[MAX_N];
int n;
int perm[MAX_N];
vector<int> who[2];
bool oktopush[MAX_N];

ll solve() {
    for(int i = 0; i <= MAX_N; i ++) {
        where[i].resize(0);
        oktopush[i] = false;
    }
    who[0].resize(0); who[1].resize(0);

    for(int i = 0; i < n; i ++) {
        where[perm[i]].push_back(i);
    }
    ll fact = 1;
    ll cnt = 1;
    for(int i = 1; i <= n; i ++) {
        if(where[i].size() == 0) {
            fact = (fact * cnt) % mod;
            cnt ++;
        } else if(where[i].size() > 2) {
            return 0;
        } else if(where[i].size() == 2) {
            if(where[i][1] - where[i][0] != 2) {
               return 0;
            }
            oktopush[where[i][0]] = true;
        }
    }

    for(int i = 0; i < n; i ++) {
        if(oktopush[i]) {
            who[i & 1].push_back(i / 2);
        }
    }

    ll ret = 1;
    for(int i = 0; i < who[0].size(); i ++) {
        if(i == 0) {
            ret = ret;
        } 
        if(i == who[0].size() - 1 && n % 2 == 0) {
            ret = (ret * ((n / 2 - who[0][i] - 1))) % mod;
        }
        if(i != 0) {
            ret = (ret * ((who[0][i] - who[0][i - 1] - 1))) % mod;
        }
    }

    for(int i = 0; i < who[1].size(); i ++) {
        if(i == 0) {
            ret = (ret * ((who[1][i] + 1))) % mod;
        } 
        if(i == who[1].size() - 1 && n % 2 == 1) {
            ret = (ret * ((n / 2 - who[1][i] - 1))) % mod;
        }
        if(i != 0) {
            ret = (ret * ((who[1][i] - who[1][i - 1] - 1))) % mod;
        }
    }

    if(who[1].empty() && n % 2 == 1) {
        ret = (ret * (n / 2 + 1)) % mod;
    }
    if(who[0].empty() && n % 2 == 1) {
        ret = 0;
    }

    return (ret * fact) % mod;
}

ll slow() {
    vector<int> tr;
    for(int i = 1; i <= n; i ++) {
        tr.push_back(i);
    }

    ll cnt = 0;

    do {
        bool ok = true;
        for(int i = 0; i < n; i ++) {
            if(i != 0 && tr[i - 1] == perm[i]) {continue;}
            if(i != n - 1 && tr[i + 1] == perm[i]) {continue;}
            ok = false;
        }

        if(ok) {
            cnt ++;
        }
    } while(next_permutation(tr.begin(), tr.end())); 
    
    return cnt;   
}

signed main() {

    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> perm[i];
    }
    cout << solve();
    return 0;

    while(true) {
        n = 5 + rand() % 5;
        for(int i = 0; i < n; i ++) {
            perm[i] = 1 + rand() % n;
        }
        if(slow() != solve()) {
            cout << endl;
            cout << n << endl;
            for(int i = 0; i < n; i ++) {
                cout << perm[i] << " ";
            }
            cout << endl;
            cout << slow() << " " << solve() << endl;
            break;
        }
        cout << n << endl;;
    }

    return 0;
}
