#include<iostream>
#include<vector>
#include<algorithm>
#include<map>
using namespace std;

int broiChisla;

int chisla[1000010];

int broiOk;

vector<int> segashnaProba;

int broiSreshtaniqNa[1000010];

int broiNesashtestvuvashtiVNachaloto;

bool proveriDaliEOk(){

    /*cout<<"poluchihme naredba: ";

    for(int i = 0; i < broiChisla; i++){
        cout<<segashnaProba[i]<<" ";
    }
    cout<<endl;*/

    for(int i = 0; i <= broiChisla; i++){
        broiSreshtaniqNa[i] = 0;
    }

    for(int i = 0; i < broiChisla; i++){
        broiSreshtaniqNa[segashnaProba[i]]++;
    }

    bool okLiE = true;

    int broiNuLiTuka = 0;

    for(int i = 1; i <= broiChisla; i++){
        //cout<<"tuka "<<i<<" se sershta "<<broiSreshtaniqNa[i]<<" pati"<<endl;
        if(broiSreshtaniqNa[i] == 0){
            broiNuLiTuka++;
        }
        if(broiSreshtaniqNa[i] > 1){
            return false;
        }
    }

    if(broiNuLiTuka != broiNesashtestvuvashtiVNachaloto){
        okLiE = false;
    }

    return okLiE;
}

int broiNesashtFaktoriel = 1;

map<vector<int>, bool> imameLiGo;

void suzdaiNova(int segIndex){
    if(segIndex == broiChisla){
        bool kakE = proveriDaliEOk();

        if(kakE == true){
            if(imameLiGo[segashnaProba] == false){
                broiOk+= broiNesashtFaktoriel;
                imameLiGo[segashnaProba] = true;
            }
        }

        return ;
    }

    if(segIndex > 0){
        int original = segashnaProba[segIndex - 1];
        segashnaProba[segIndex - 1] = chisla[segIndex];
        suzdaiNova(segIndex+1);
        segashnaProba[segIndex - 1] = original;
    }

    if(segIndex < broiChisla - 1){
        int original = segashnaProba[segIndex + 1];
        segashnaProba[segIndex + 1] = chisla[segIndex];
        suzdaiNova(segIndex+1);
        segashnaProba[segIndex + 1] = original;
    }
}

int nachalenCountingSort[1000010];

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>broiChisla;

    for(int i = 0; i < broiChisla; i++){
        cin>>chisla[i];
        nachalenCountingSort[chisla[i]]++;
    }

    segashnaProba.resize(broiChisla);

    for(int i = 1; i <= broiChisla; i++){
        if(nachalenCountingSort[i] == 0){
            broiNesashtestvuvashtiVNachaloto++;
        }
    }

    for(int i = 1; i <= broiNesashtestvuvashtiVNachaloto; i++){
        broiNesashtFaktoriel *= i;
    }

    suzdaiNova(0);

    cout<<broiOk<<endl;

    return 0;
}
