#include<bits/stdc++.h>
using namespace std;

int const MAXN=5001, inf=1e9+7;
int n, m, dks[MAXN], used[MAXN];
int v[MAXN][MAXN];

void dijkstra()
{
    int minn=inf, edge;
    dks[1]=0;
    for(int i=2;i<=n;i++)
    {
        if(v[1][i] == 0) dks[i]=inf;
        else dks[i] = v[1][i];
    }
    used[1]=1;
    for(int u=1;u<n-1;u++)
    {
        minn=inf;
        for(int i=2;i<=n;i++)
        {
            if(!used[i] && minn > dks[i])
            {
                minn=dks[i];
                edge=i;
            }
        }
        used[edge]=1;
        for(int i=2;i<=n;i++)
        {
            if(!used[i] && v[edge][i] != 0)
            {
                if(dks[edge] + v[edge][i] < dks[i])
                {
                    dks[i] = dks[edge] + v[edge][i];
                }
            }
        }
    }
}

void read()
{
    int x, y, d, st;
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>x>>y>>d>>st;
        v[x][y]=d;
    }
    dijkstra();
    if(dks[n] == inf) cout<<-1<<endl;
    else cout<<dks[n]<<endl;
}

int main()
{
    read();
    return 0;
}
