#include<bits/stdc++.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("avx2")
#define endl "\n"

using namespace std;

struct edge
{
    int x, y, w, magic;
    edge() { }
    edge(int x, int y, int w, int magic) :x(x), y(y), w(w), magic(magic) { }
};

const int N = 2010, inf = 1e9;
int n, m;
vector<edge> v[N];
int path[N][N];

void floid()
{
    for(int k = 1; k <= n; ++k)
        for(int i = 1; i <= n; ++i)
            for(int j = 1; j <= n; ++j)
                path[i][j] = min(path[i][j], path[i][k] + path[k][j]);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int x, y, w, magic;
    cin >> n >> m;

    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= n; ++j) path[i][j] = inf;
    for(int i = 0; i < m; ++i)
    {
        cin >> x >> y >> w >> magic;
        path[x][y] = min(path[x][y], w);
        //cout << x << " " << y << " " << w << endl;
        v[i].push_back({x, y, w, magic});
    }

    floid();
    //for(int i = 1; i <= n; ++i, cout << endl)
    //    for(int j = 1; j <= n; ++j) cout << path[i][j] << " ";
    cout << path[1][n] << endl;
    return 0;
}
/*
7 8
1 2 1 0
2 4 1 0
4 6 1 0
6 7 3 0
1 3 5 0
3 5 2 0
5 7 3 0
3 4 3 0
*/
