#include<cstring>
#include<vector>
#include<queue>
#include<cstdio>
using namespace std;
const int maxn=128;
struct edge
{
    int ver,p;
    edge(){ver=p=0;}
    edge(int _ver,int _p)
    {
        ver=_ver;
        p=_p;
    }
    bool operator<(const edge &e)const
    {
        return p>e.p;
    }
};
int n,m;
vector<edge>v[maxn];
unsigned int d[maxn];
bool used[maxn];
void read()
{
    scanf("%d%d",&n,&m);
    int from,to,dist,magic;
    for(int i=0;i<m;++i)
    {
        scanf("%d%d%d%d",&from,&to,&dist,&magic);
        v[from].push_back(edge(to,dist));
    }
}
void Dijkstra()
{
    memset(d,-1,sizeof(d));
    d[1]=0;
    edge e(1,0),nb;
    priority_queue<edge>q;
    q.push(e);
    int i,sz;
    while(!q.empty())
    {
        e=q.top();
        q.pop();
        if(e.p<=d[e.ver])
        {
            if(!used[e.ver])
            {
                used[e.ver]=true;
                sz=v[e.ver].size();
                for(i=0;i<sz;++i)
                {
                    nb=v[e.ver][i];
                    if(d[nb.ver]>e.p+nb.p)
                    {
                        nb.p+=e.p;
                        d[nb.ver]=nb.p;
                        q.push(nb);
                    }
                }
            }
        }
    }
    printf("%u\n",d[n]);
}
int main()
{
	/*ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);*/
	read();
	Dijkstra();
return 0;
}
/*
6 7
1 2 1 0
2 3 1 0
1 3 20 0
3 4 1 0
4 5 1 0
5 6 1 0
4 6 50 0

ans=5
*/
