/// Излитам с триста,
/// шофирам мощно
/// и набелязвам
/// веднага тебе точно (...)

#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = 2048;
int n, m;
unsigned int d[maxn];
bool used[maxn];
struct edge
{
    int ver;
    int p;
    bool operator<(const edge&e)const
    {
        return p > e.p;
    }
};
vector <edge> v [maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    int i, a, b, c, d;
    for (i=1; i<=m; ++i)
    {
        cin >> a >> b >> c >> d ;
        v[a].push_back({b,c});
        v[b].push_back({a,c});
    }
}

void Dijkstra(int s)
{
    memset(d, -1, sizeof(d));
    memset(used, 0, sizeof(used));
    d[s] = 0;
    priority_queue<edge> q;
    edge w = {s,0}, e, nb;
    q.push(w);
    int i, len;

    while (!q.empty())
    {
        e = q.top();  q.pop();
        if (e.p <= d[e.ver])
        {
            if (!used[e.ver])
            {
                used[e.ver] = true;
                len = (int)(v[e.ver].size());
                for (i=0; i<len; ++i)
                {
                    nb = v[e.ver][i];
                    if (e.p + nb.p <= d[nb.ver])
                    {
                        nb.p += e.p;
                        d[nb.ver] = nb.p;
                        q.push(nb);
                    }
                }
            }
        }
    }
}

void solve()
{
    Dijkstra(1);
    cout << d[n] << endl;
}

int main()
{
    read();
    solve();
    return 0;
}