#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int N;
vector<int> Q;

void read() {
    cin >> N;

    Q.resize(N);
    for (int &i : Q) {
        cin >> i;
    }
}

void solve() {
    if (N & 1) {
        cout << 0 << endl;
        return;
    } else {
        cout << 1 << endl;
        return;
    }

    vector<int> perm(N, -1);

    perm[1] = Q[0];

    if (perm[N - 2] != -1) {
        cout << 0 << endl;
        return;
    }

    perm[N - 2] = Q[N - 1];

    for (int i = 3; i < N; i += 2) {
        perm[i] = Q[i - 1];
    }

    for (int i = 0; i < N; i += 2) {
        perm[i] = Q[i + 1];
    }

    set<int> s(perm.begin(), perm.end());

    cout << (s.size() == N ? 1 : 0) << endl;
}

int main() {
    setIO();

    read();

    solve();
}
