#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int b[6];

void read() {
    for (int i = 1; i <= 5; i++) {
        cin >> b[i];
    }
}

int conflict(int a, int b) {
    return __builtin_popcount(a & b);
}

int n = 0;
int answer = 1e9;

void bruteforce(int pos, int total, int pr) {
    if (total >= answer) {
        return;
    }

    if (pos == n) {
        answer = total;
        return;
    }

    int minConflict = 1e9;
    for (int i = 1; i < 32; i++) {
        int numBits = __builtin_popcount(i);

        if (b[numBits]) {
            minConflict = min(minConflict, conflict(pr, i));
        }
    }

    for (int i = 1; i < 32; i++) {
        int numBits = __builtin_popcount(i);

        if (b[numBits] && conflict(pr, i) == minConflict) {
            b[numBits]--;
            bruteforce(pos + 1, total + conflict(pr, i), i);
            b[numBits]++;
        }
    }
}

void solve() {
    for (int i = 1; i <= 5; i++) {
        n += b[i];
    }

    bruteforce(0, 0, 0);

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
